#ifndef TDx_Library_DefnsH
#define TDx_Library_DefnsH

// ==========================================================================
// File:        TDx_Library_Defns.H
// Description: This file contains standard definitions used with the various
//              TDx_Library components.
//
// "TDx_Library"
// (c) 2001, BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// define our version of the DirectX SDK's common tags 
// --------------------------------------------------------------------------
#define     word        WORD
#define     dword       DWORD
#define     ulong       ULONG
#define     large_int   LARGE_INTEGER

// --------------------------------------------------------------------------
// define any extra codes required for error values
// --------------------------------------------------------------------------
#define TDX_ERROR              -1
#define TDX_BADPARAMS          -2
#define TDX_NOTCREATED         -3
#define TDX_ALREADYCREATED     -4

// --------------------------------------------------------------------------
// Event Defn:  TDx_Event
// Description: This is a generic event method declaration that is used 
//              to signal simple events such as OnCreate and OnRelease
//---------------------------------------------------------------------------
typedef __fastcall void (__closure*     TDx_Event) 
                        ( TObject*      Sender );

// --------------------------------------------------------------------------
// Event Defn:  TDx_NotifyEvent
// Description: This is a generic event method declaration that is used 
//              to signal events that require a single integer value
// --------------------------------------------------------------------------
typedef __fastcall void (__closure*     TDx_NotifyEvent) 
                        ( TObject*      Sender,
                          int           Notification );

// --------------------------------------------------------------------------
// Event Defn:  TDx_Error
// Description: This event method is used to convey detailed information 
//              about any kind of error that has occurred within the 
//              TDx_Library components.
// --------------------------------------------------------------------------
typedef	__fastcall void	(__closure*     TDx_Error)
                        ( TObject*      Sender,
                          AnsiString    Function,
                          AnsiString    Error,
                          AnsiString    ErrorMessage );

#endif
