// --------------------------------------------------------------------------

// ==========================================================================
// File:         TD3DColorValue.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               Brian Austin (documentation)
// Description:  This file contains the code for the TD3DColorValue Component 
//
// "TDx_3DI_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TD3DColorValue.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_3DI_Library_Defns"
#pragma link "TDx_3DI_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TD3DColorValue*)
{
    new TD3DColorValue(NULL);
}
// --------------------------------------------------------------------------
namespace Td3dcolorvalue
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TD3DColorValue)};
        RegisterComponents("TDx_3DI", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TD3DColorValue::TD3DColorValue()
// Description: The default constructor for the TD3DColorValue object.
// --------------------------------------------------------------------------
__fastcall TD3DColorValue::TD3DColorValue(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TD3DColorValue::~TD3DColorValue()
// Description: The destructor for the TD3DColorValue object.
// --------------------------------------------------------------------------
__fastcall TD3DColorValue::~TD3DColorValue()
{
}
// --------------------------------------------------------------------------
// Property:    A
// Description: The A property defines the alpha component of the color. 
//              This property is unioned with the "a" property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DColorValue::FGetA()
{
return fD3DCOLORVALUE.dvA;
}
// --------------------------------------------------------------------------
void __fastcall TD3DColorValue::FSetA( D3DVALUE pA )
{
fD3DCOLORVALUE.dvA = pA;
}
// --------------------------------------------------------------------------
// Property:    B
// Description: The B property defines the blue component of the color. 
//              This property is unioned with the "b" property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DColorValue::FGetB()
{
return fD3DCOLORVALUE.dvB;
}
// --------------------------------------------------------------------------
void __fastcall TD3DColorValue::FSetB( D3DVALUE pB )
{
fD3DCOLORVALUE.dvB = pB;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TD3DColorValue method or fget/fset. 
//              eg. D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TD3DColorValue::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TD3DColorValue::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    G
// Description: The G property defines the green component of the color. 
//              This property is unioned with the "g" property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DColorValue::FGetG()
{
return fD3DCOLORVALUE.dvG;
}
// --------------------------------------------------------------------------
void __fastcall TD3DColorValue::FSetG( D3DVALUE pG )
{
fD3DCOLORVALUE.dvG = pG;
}
// --------------------------------------------------------------------------
// Property:    R
// Description: The R property defines the red component of the color. 
//              This property is unioned with the "R" property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DColorValue::FGetR()
{
return fD3DCOLORVALUE.dvR;
}
// --------------------------------------------------------------------------
void __fastcall TD3DColorValue::FSetR( D3DVALUE pR )
{
fD3DCOLORVALUE.dvR = pR;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              D3DCOLORVALUE structure. 
// --------------------------------------------------------------------------
dword __fastcall TD3DColorValue::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TD3DColorValue::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    a
// Description: The a property defines the alpha component of the color. 
//              This property is unioned with the "A" property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DColorValue::FGeta()
{
return fD3DCOLORVALUE.a;
}
// --------------------------------------------------------------------------
void __fastcall TD3DColorValue::FSeta( D3DVALUE pa )
{
fD3DCOLORVALUE.a = pa;
}
// --------------------------------------------------------------------------
// Property:    b
// Description: The b property defines the blue component of the color. 
//              This property is unioned with the "B" property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DColorValue::FGetb()
{
return fD3DCOLORVALUE.b;
}
// --------------------------------------------------------------------------
void __fastcall TD3DColorValue::FSetb( D3DVALUE pb )
{
fD3DCOLORVALUE.b = pb;
}
// --------------------------------------------------------------------------
// Property:    g
// Description: The g property defines the green component of the color. 
//              This property is unioned with the "G" property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DColorValue::FGetg()
{
return fD3DCOLORVALUE.g;
}
// --------------------------------------------------------------------------
void __fastcall TD3DColorValue::FSetg( D3DVALUE pg )
{
fD3DCOLORVALUE.g = pg;
}
// --------------------------------------------------------------------------
// Property:    r
// Description: The r property defines the red component of the color. 
//              This property is unioned with the "R" property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DColorValue::FGetr()
{
return fD3DCOLORVALUE.r;
}
// --------------------------------------------------------------------------
void __fastcall TD3DColorValue::FSetr( D3DVALUE pr )
{
fD3DCOLORVALUE.r = pr;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TD3DColorValue's internal D3DCOLORVALUE structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TD3DColorValue::Clear()
{
fErrorValue = D3D_OK;
fSize = sizeof(D3DCOLORVALUE);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
D3DCOLORVALUE* __fastcall TD3DColorValue::FGetInternal_D3DCOLORVALUE_Ptr()
{
return &fD3DCOLORVALUE;
}
// --------------------------------------------------------------------------
void __fastcall TD3DColorValue::FSetInternal_D3DCOLORVALUE( D3DCOLORVALUE* pD3DCOLORVALUE )
{
if (pD3DCOLORVALUE==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DColorValue::FSetInternal_D3DCOLORVALUE()", "TDX_ERROR", "The supplied D3DCOLORVALUE* was NULL" );
    return;
    }

CopyMemory( &fD3DCOLORVALUE, pD3DCOLORVALUE, sizeof(D3DCOLORVALUE) );
Internal_D3DCOLORVALUE_Update();
}
// --------------------------------------------------------------------------
void __fastcall TD3DColorValue::Internal_D3DCOLORVALUE_Update()
{
}

// --------------------------------------------------------------------------
