// --------------------------------------------------------------------------

// ==========================================================================
// File:         TD3DDP_PtrStride.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               Brian Austin (documentation)
// Description:  This file contains the code for the TD3DDP_PtrStride 
//               Component 
//
// "TDx_3DI_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TD3DDP_PtrStride.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_3DI_Library_Defns"
#pragma link "TDx_3DI_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TD3DDP_PtrStride*)
{
    new TD3DDP_PtrStride(NULL);
}
// --------------------------------------------------------------------------
namespace Td3ddp_ptrstride
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TD3DDP_PtrStride)};
        RegisterComponents("TDx_3DI", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TD3DDP_PtrStride::TD3DDP_PtrStride()
// Description: The default constructor for the TD3DDP_PtrStride object.
// --------------------------------------------------------------------------
__fastcall TD3DDP_PtrStride::TD3DDP_PtrStride(TComponent* Owner)
    : TComponent(Owner)
{
fD3DDP_PTRSTRIDE=NULL;
fArraySize=0;
ArraySize=1;
ClearAll();
}
// --------------------------------------------------------------------------
// Destructor:  TD3DDP_PtrStride::~TD3DDP_PtrStride()
// Description: The destructor for the TD3DDP_PtrStride object.
// --------------------------------------------------------------------------
__fastcall TD3DDP_PtrStride::~TD3DDP_PtrStride()
{
// destroy internals
if (ArraySize!=0) ArraySize = 0;
}
// --------------------------------------------------------------------------
// Property:    ArraySize
// Description: The ArraySize property contains the number of internal 
//              D3DDP_PTRSTRIDE structures wrapped inside the 
//              TD3DDP_PtrStride component. 
//              By default the ArraySize is initialized to 1, meaning that 
//              this TD3DDP_PtrStride component wraps a single 
//              D3DDP_PTRSTRIDE structure. To wrap multiple structures, set 
//              the TD3DDP_PtrStride::ArraySize to the total number of 
//              internal structures desired. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDP_PtrStride::FGetArraySize()
{
return fArraySize;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDP_PtrStride::FSetArraySize( dword pArraySize )
{
// check for size==0
if (pArraySize==0)
    {
    // de-allocate old memory
    delete[] fD3DDP_PTRSTRIDE;
    fD3DDP_PTRSTRIDE = NULL;
    fArraySize = 0;
    return;
    }

// is anything allocated?
if (fArraySize==0)
    {
    // nope. need to allocate memory for pointers to internal structures
    fD3DDP_PTRSTRIDE = new D3DDP_PTRSTRIDE[pArraySize];
    if (fD3DDP_PTRSTRIDE==NULL)
        {
        fArraySize = 0;
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TD3DDP_PTRSTRIDE::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal D3DDP_PTRSTRIDE structure pointers.");
        return;
        }
    // setup defaults
    fArraySize = pArraySize;
    ClearAll();
    }
else
    // already allocated... has the size increased?
    if (pArraySize>fArraySize)
        {
        // allocate space for the new structures
        D3DDP_PTRSTRIDE* temp_D3DDP_PTRSTRIDE = new D3DDP_PTRSTRIDE[pArraySize];
        if (temp_D3DDP_PTRSTRIDE==NULL)
            {
            fErrorValue = TDX_ERROR;
            if (FOnError) FOnError(this, "TD3DDP_PTRSTRIDE::FSetArraySize()", "TDX_ERROR", "Could not allocate extra memory for storing internal D3DDP_PTRSTRIDE structures.");
            return;
            }
        // clear new data areas
        ZeroMemory( &temp_D3DDP_PTRSTRIDE[fArraySize], sizeof(D3DDP_PTRSTRIDE)*(pArraySize-fArraySize) );
        // duplicate existing data
        CopyMemory( &temp_D3DDP_PTRSTRIDE[0], &fD3DDP_PTRSTRIDE[0], sizeof(D3DDP_PTRSTRIDE)*fArraySize);
        // de-allocate old memory
        delete[] fD3DDP_PTRSTRIDE;
        // re-assign the new memory
        fD3DDP_PTRSTRIDE = temp_D3DDP_PTRSTRIDE;
        // store new array size
        fArraySize = pArraySize;
        }
    else
        // already allocated... has the size reduced?
        if (pArraySize<fArraySize)
            {
            // allocate space for the new structures
            D3DDP_PTRSTRIDE* temp_D3DDP_PTRSTRIDE = new D3DDP_PTRSTRIDE[pArraySize];
            if (temp_D3DDP_PTRSTRIDE==NULL)
                {
                fErrorValue = TDX_ERROR;
                if (FOnError) FOnError(this, "TD3DDP_PTRSTRIDE::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal D3DDP_PTRSTRIDE structures.");
                return;
                }
            // duplicate existing data
            CopyMemory( &temp_D3DDP_PTRSTRIDE[0], &fD3DDP_PTRSTRIDE[0], sizeof(D3DDP_PTRSTRIDE)*pArraySize);
            // de-allocate the old memory
            delete[] fD3DDP_PTRSTRIDE;
            // re-assign the new memory
            fD3DDP_PTRSTRIDE = temp_D3DDP_PTRSTRIDE;
            // store new array size
            fArraySize = pArraySize;
            }
// else - size is the same.
}
// --------------------------------------------------------------------------
// Property:    Data
// Description: The Data property references a composite vertex format or an 
//              array of distinct vertex components. 
// --------------------------------------------------------------------------
void* __fastcall TD3DDP_PtrStride::FGetData( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDP_PtrStride::FGetData()", "TDX_ERROR", "Internal Array size is 0.");
     return (void*) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDP_PtrStride::FGetData()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (void*) NULL;
    }

return fD3DDP_PTRSTRIDE[pArrayIndex].lpvData;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDP_PtrStride::FSetData( dword pArrayIndex, void* pData )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDP_PtrStride::FSetData()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDP_PtrStride::FSetData()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DDP_PTRSTRIDE[pArrayIndex].lpvData = pData;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TD3DDP_PtrStride method or 
//              fget/fset. eg. D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TD3DDP_PtrStride::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDP_PtrStride::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of a single 
//              internal D3DDP_PTRSTRIDE structure. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDP_PtrStride::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDP_PtrStride::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    SizeAll
// Description: The SizeAll property contains the size in bytes of all 
//              internal D3DDP_PTRSTRIDE structures. This result is the same 
//              as multiplying TD3DDP_PtrStride::ArraySize and 
//              TD3DDP_PtrStride::Size. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDP_PtrStride::FGetSizeAll()
{
return fArraySize * fSize;
}
// --------------------------------------------------------------------------
// Property:    Stride
// Description: The Stride property defines the stride, in bytes, of the 
//              composite vertex format, or the stride, in bytes, of each 
//              element in the array of distinct vertex components. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDP_PtrStride::FGetStride( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDP_PtrStride::FGetStride()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDP_PtrStride::FGetStride()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fD3DDP_PTRSTRIDE[pArrayIndex].dwStride;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDP_PtrStride::FSetStride( dword pArrayIndex, dword pStride )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDP_PtrStride::FSetStride()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDP_PtrStride::FSetStride()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DDP_PTRSTRIDE[pArrayIndex].dwStride = pStride;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TD3DDP_PtrStride's internal D3DDP_PTRSTRIDE structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// Params:      pArrayIndex - 
//                The ArrayIndex parameter determines which internal structure 
//                needs to be cleared. Correct values range from 0 to 
//                TD3DDP_PtrStride::ArraySize-1. 
// --------------------------------------------------------------------------
void __fastcall TD3DDP_PtrStride::Clear( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDP_PtrStride::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDP_PtrStride::Clear()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

ZeroMemory( &fD3DDP_PTRSTRIDE[pArrayIndex], sizeof(D3DDP_PTRSTRIDE) );
}


// --------------------------------------------------------------------------
// Method:      ClearAll()
// Description: The ClearAll() method can be used to clear the contents of 
//              all the internal D3DDP_PTRSTRIDE structures of the 
//              TD3DDP_PtrStride component. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TD3DDP_PtrStride::ClearAll()
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DDP_PtrStride::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }

ZeroMemory( &fD3DDP_PTRSTRIDE[0], sizeof(D3DDP_PTRSTRIDE)*fArraySize );
}


// --------------------------------------------------------------------------
// Internal Structure Access 
// --------------------------------------------------------------------------
D3DDP_PTRSTRIDE* __fastcall TD3DDP_PtrStride::FGetInternal_D3DDP_PTRSTRIDE_Ptr()
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DDP_PtrStride::FGetInternal_D3DDP_PTRSTRIDE_Ptr()", "TDX_ERROR", "Internal Array size is 0." );
    return NULL;
    }
return fD3DDP_PTRSTRIDE;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDP_PtrStride::FSetInternal_D3DDP_PTRSTRIDE( dword pArrayIndex, D3DDP_PTRSTRIDE* pD3DDP_PTRSTRIDE )
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DDP_PtrStride::FSetInternal_D3DDP_PTRSTRIDE()", "TDX_ERROR", "Internal Array size is 0." );
    return;
    }
if (pD3DDP_PTRSTRIDE==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DDP_PtrStride::FSetInternal_D3DDP_PTRSTRIDE()", "TDX_ERROR", "The supplied D3DDP_PTRSTRIDE* was NULL" );
    return;
    }
CopyMemory( &fD3DDP_PTRSTRIDE[pArrayIndex], pD3DDP_PTRSTRIDE, sizeof(D3DDP_PTRSTRIDE) );
Internal_D3DDP_PTRSTRIDE_Update();
}
// --------------------------------------------------------------------------
void __fastcall TD3DDP_PtrStride::Internal_D3DDP_PTRSTRIDE_Update()
{
}

// --------------------------------------------------------------------------
