// --------------------------------------------------------------------------

// ==========================================================================
// File:         TD3DDevInfo_TextureManager.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               Brian Austin (documentation)
// Description:  This file contains the code for the 
//               TD3DDevInfo_TextureManager Component 
//
// "TDx_3DI_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TD3DDevInfo_TextureManager.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_3DI_Library_Defns"
#pragma link "TDx_3DI_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TD3DDevInfo_TextureManager*)
{
    new TD3DDevInfo_TextureManager(NULL);
}
// --------------------------------------------------------------------------
namespace Td3ddevinfo_texturemanager
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TD3DDevInfo_TextureManager)};
        RegisterComponents("TDx_3DI", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TD3DDevInfo_TextureManager::TD3DDevInfo_TextureManager()
// Description: The default constructor for the TD3DDevInfo_TextureManager object.
// --------------------------------------------------------------------------
__fastcall TD3DDevInfo_TextureManager::TD3DDevInfo_TextureManager(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TD3DDevInfo_TextureManager::~TD3DDevInfo_TextureManager()
// Description: The destructor for the TD3DDevInfo_TextureManager object.
// --------------------------------------------------------------------------
__fastcall TD3DDevInfo_TextureManager::~TD3DDevInfo_TextureManager()
{
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TD3DDevInfo_TextureManager method 
//              or fget/fset. eg. D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TD3DDevInfo_TextureManager::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDevInfo_TextureManager::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    LastPri
// Description: The LastPri property contains the priority of the last 
//              texture removed from memory. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDevInfo_TextureManager::FGetLastPri()
{
return fD3DDEVINFO_TEXTUREMANAGER.dwLastPri;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDevInfo_TextureManager::FSetLastPri( dword pLastPri )
{
fD3DDEVINFO_TEXTUREMANAGER.dwLastPri = pLastPri;
}
// --------------------------------------------------------------------------
// Property:    NumEvicts
// Description: The NumEvicts property contains the number of textures 
//              removed during the last frame. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDevInfo_TextureManager::FGetNumEvicts()
{
return fD3DDEVINFO_TEXTUREMANAGER.dwNumEvicts;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDevInfo_TextureManager::FSetNumEvicts( dword pNumEvicts )
{
fD3DDEVINFO_TEXTUREMANAGER.dwNumEvicts = pNumEvicts;
}
// --------------------------------------------------------------------------
// Property:    NumTexturesUsed
// Description: The NumTexturesUsed contains the total number of textures 
//              used in the last frame. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDevInfo_TextureManager::FGetNumTexturesUsed()
{
return fD3DDEVINFO_TEXTUREMANAGER.dwNumTexturesUsed;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDevInfo_TextureManager::FSetNumTexturesUsed( dword pNumTexturesUsed )
{
fD3DDEVINFO_TEXTUREMANAGER.dwNumTexturesUsed = pNumTexturesUsed;
}
// --------------------------------------------------------------------------
// Property:    NumUsedTexInVid
// Description: The NumUsedTexInVid property contains how many video memory 
//              textures were used in the last frame. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDevInfo_TextureManager::FGetNumUsedTexInVid()
{
return fD3DDEVINFO_TEXTUREMANAGER.dwNumUsedTexInVid;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDevInfo_TextureManager::FSetNumUsedTexInVid( dword pNumUsedTexInVid )
{
fD3DDEVINFO_TEXTUREMANAGER.dwNumUsedTexInVid = pNumUsedTexInVid;
}
// --------------------------------------------------------------------------
// Property:    NumVidCreates
// Description: The NumVidCreates property contains how many video memory 
//              textures were created during the last frame. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDevInfo_TextureManager::FGetNumVidCreates()
{
return fD3DDEVINFO_TEXTUREMANAGER.dwNumVidCreates;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDevInfo_TextureManager::FSetNumVidCreates( dword pNumVidCreates )
{
fD3DDEVINFO_TEXTUREMANAGER.dwNumVidCreates = pNumVidCreates;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              D3DDEVINFO_TEXTUREMANAGER structure. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDevInfo_TextureManager::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDevInfo_TextureManager::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    Thrashing
// Description: The Thrashing property indicates whether thrashing occured in 
//              the last frame. 
// --------------------------------------------------------------------------
bool __fastcall TD3DDevInfo_TextureManager::FGetThrashing()
{
return fD3DDEVINFO_TEXTUREMANAGER.bThrashing;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDevInfo_TextureManager::FSetThrashing( bool pThrashing )
{
fD3DDEVINFO_TEXTUREMANAGER.bThrashing = pThrashing;
}
// --------------------------------------------------------------------------
// Property:    TotalBytes
// Description: The TotalBytes property defines how much memory, in bytes, 
//              that is allocated to managed textures. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDevInfo_TextureManager::FGetTotalBytes()
{
return fD3DDEVINFO_TEXTUREMANAGER.dwTotalBytes;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDevInfo_TextureManager::FSetTotalBytes( dword pTotalBytes )
{
fD3DDEVINFO_TEXTUREMANAGER.dwTotalBytes = pTotalBytes;
}
// --------------------------------------------------------------------------
// Property:    TotalManaged
// Description: The TotalManaged property defines how many textures are 
//              currently being managed. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDevInfo_TextureManager::FGetTotalManaged()
{
return fD3DDEVINFO_TEXTUREMANAGER.dwTotalManaged;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDevInfo_TextureManager::FSetTotalManaged( dword pTotalManaged )
{
fD3DDEVINFO_TEXTUREMANAGER.dwTotalManaged = pTotalManaged;
}
// --------------------------------------------------------------------------
// Property:    WorkingSet
// Description: The WorkingSet property defines how many textures are 
//              currently in video memory. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDevInfo_TextureManager::FGetWorkingSet()
{
return fD3DDEVINFO_TEXTUREMANAGER.dwWorkingSet;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDevInfo_TextureManager::FSetWorkingSet( dword pWorkingSet )
{
fD3DDEVINFO_TEXTUREMANAGER.dwWorkingSet = pWorkingSet;
}
// --------------------------------------------------------------------------
// Property:    WorkingSetBytes
// Description: The WorkingSetBytes property defines how much video memory, 
//              in bytes, is being used by resident textures. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDevInfo_TextureManager::FGetWorkingSetBytes()
{
return fD3DDEVINFO_TEXTUREMANAGER.dwWorkingSetBytes;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDevInfo_TextureManager::FSetWorkingSetBytes( dword pWorkingSetBytes )
{
fD3DDEVINFO_TEXTUREMANAGER.dwWorkingSetBytes = pWorkingSetBytes;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TD3DDevInfo_TextureManager's internal 
//              D3DDEVINFO_TEXTUREMANAGER structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TD3DDevInfo_TextureManager::Clear()
{
fErrorValue = D3D_OK;
fD3DDEVINFO_TEXTUREMANAGER.dwLastPri = 0;
fD3DDEVINFO_TEXTUREMANAGER.dwNumEvicts = 0;
fD3DDEVINFO_TEXTUREMANAGER.dwNumTexturesUsed = 0;
fD3DDEVINFO_TEXTUREMANAGER.dwNumUsedTexInVid = 0;
fD3DDEVINFO_TEXTUREMANAGER.dwNumVidCreates = 0;
fSize = sizeof(D3DDEVINFO_TEXTUREMANAGER);
fD3DDEVINFO_TEXTUREMANAGER.bThrashing = false;
fD3DDEVINFO_TEXTUREMANAGER.dwTotalBytes = 0;
fD3DDEVINFO_TEXTUREMANAGER.dwTotalManaged = 0;
fD3DDEVINFO_TEXTUREMANAGER.dwWorkingSet = 0;
fD3DDEVINFO_TEXTUREMANAGER.dwWorkingSetBytes = 0;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
D3DDEVINFO_TEXTUREMANAGER* __fastcall TD3DDevInfo_TextureManager::FGetInternal_D3DDEVINFO_TEXTUREMANAGER_Ptr()
{
return &fD3DDEVINFO_TEXTUREMANAGER;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDevInfo_TextureManager::FSetInternal_D3DDEVINFO_TEXTUREMANAGER( D3DDEVINFO_TEXTUREMANAGER* pD3DDEVINFO_TEXTUREMANAGER )
{
if (pD3DDEVINFO_TEXTUREMANAGER==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DDevInfo_TextureManager::FSetInternal_D3DDEVINFO_TEXTUREMANAGER()", "TDX_ERROR", "The supplied D3DDEVINFO_TEXTUREMANAGER* was NULL" );
    return;
    }

CopyMemory( &fD3DDEVINFO_TEXTUREMANAGER, pD3DDEVINFO_TEXTUREMANAGER, sizeof(D3DDEVINFO_TEXTUREMANAGER) );
Internal_D3DDEVINFO_TEXTUREMANAGER_Update();
}
// --------------------------------------------------------------------------
void __fastcall TD3DDevInfo_TextureManager::Internal_D3DDEVINFO_TEXTUREMANAGER_Update()
{
}

// --------------------------------------------------------------------------
