// --------------------------------------------------------------------------

// ==========================================================================
// File:         TD3DLight.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               Brian Austin (documentation)
// Description:  This file contains the code for the TD3DLight Component 
//
// "TDx_3DI_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TD3DLight.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_3DI_Library_Defns"
#pragma link "TDx_3DI_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TD3DLight*)
{
    new TD3DLight(NULL);
}
// --------------------------------------------------------------------------
namespace Td3dlight
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TD3DLight)};
        RegisterComponents("TDx_3DI", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TD3DLight::TD3DLight()
// Description: The default constructor for the TD3DLight object.
// --------------------------------------------------------------------------
__fastcall TD3DLight::TD3DLight(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TD3DLight::~TD3DLight()
// Description: The destructor for the TD3DLight object.
// --------------------------------------------------------------------------
__fastcall TD3DLight::~TD3DLight()
{
}
// --------------------------------------------------------------------------
// Property:    Ambient
// Description: The Ambient property contains a TD3DColorValue component 
//              defining the ambient color emitted by the light. 
// --------------------------------------------------------------------------
TD3DColorValue* __fastcall TD3DLight::FGetAmbient()
{
if (ComponentState.Contains(csDesigning) &&
    (fAmbient!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fAmbient)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fAmbient=NULL;
    }
return fAmbient;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLight::FSetAmbient( TD3DColorValue* pAmbient )
{
fAmbient = pAmbient;
}
// --------------------------------------------------------------------------
// Property:    Attenuation0
// Description: The Attenuation0 property contains a D3DVALUE defining the 
//              light's constant attentuation factor, which in turn helps 
//              define how a light's intensity varies over distance. 
//              
//              Attenuation does not affect directional lights and can range 
//              from 0.0 to infinity. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DLight::FGetAttenuation0()
{
return fD3DLIGHT7.dvAttenuation0;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLight::FSetAttenuation0( D3DVALUE pAttenuation0 )
{
fD3DLIGHT7.dvAttenuation0 = pAttenuation0;
}
// --------------------------------------------------------------------------
// Property:    Attenuation1
// Description: The Attenuation1 property contains a D3DVALUE defining the 
//              light's linear attentuation factor, which in turn helps 
//              define how a light's intensity varies over distance. 
//              
//              Attenuation does not affect directional lights and can range 
//              from 0.0 to infinity. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DLight::FGetAttenuation1()
{
return fD3DLIGHT7.dvAttenuation1;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLight::FSetAttenuation1( D3DVALUE pAttenuation1 )
{
fD3DLIGHT7.dvAttenuation1 = pAttenuation1;
}
// --------------------------------------------------------------------------
// Property:    Attenuation2
// Description: The Attenuation2 property contains a D3DVALUE defining the 
//              light's quadratic attentuation factor, which in turn helps 
//              define how a light's intensity varies over distance. 
//              
//              Attenuation does not affect directional lights and can range 
//              from 0.0 to infinity. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DLight::FGetAttenuation2()
{
return fD3DLIGHT7.dvAttenuation2;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLight::FSetAttenuation2( D3DVALUE pAttenuation2 )
{
fD3DLIGHT7.dvAttenuation2 = pAttenuation2;
}
// --------------------------------------------------------------------------
// Property:    Diffuse
// Description: The Diffuse property contains a TD3DColorValue component 
//              defining the diffuse color emitted by the light. 
// --------------------------------------------------------------------------
TD3DColorValue* __fastcall TD3DLight::FGetDiffuse()
{
if (ComponentState.Contains(csDesigning) &&
    (fDiffuse!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fDiffuse)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fDiffuse=NULL;
    }
return fDiffuse;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLight::FSetDiffuse( TD3DColorValue* pDiffuse )
{
fDiffuse = pDiffuse;
}
// --------------------------------------------------------------------------
// Property:    Direction
// Description: The Direction property contains a TD3DVector component 
//              indicating the direction the light is pointing in world 
//              space. 
//              
//              This propety only has meaning for the directional and 
//              spotlight types of light source. 
//              This vector need not be normalized but should be of non zero 
//              length. 
// --------------------------------------------------------------------------
D3DVECTOR __fastcall TD3DLight::FGetDirection()
{
return fD3DLIGHT7.dvDirection;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLight::FSetDirection( D3DVECTOR pDirection )
{
fD3DLIGHT7.dvDirection = pDirection;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TD3DLight method or fget/fset. eg. 
//              D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TD3DLight::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLight::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Falloff
// Description: The Falloff property contains a D3DVALUE representing the 
//              decrease in illumination from a spotlight's umbra, defined by 
//              the Theta property, and the outer edge of the penumbra, 
//              defined by the Phi property. 
//              
//              A value of 1.0 will result in a linear falloff from the umbra 
//              to the penumbra. 
//              Values greater than 1.0 will cause the light to fall off 
//              quickly at first and then fade slowly to the penumbra while a 
//              value less than 1.0 will create the opposite effect. 
//              The effect of non 1.0 values is subtle and affects 
//              performance a little, thus a 1.0 value is generally 
//              reccomended. 
//              
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DLight::FGetFalloff()
{
return fD3DLIGHT7.dvFalloff;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLight::FSetFalloff( D3DVALUE pFalloff )
{
fD3DLIGHT7.dvFalloff = pFalloff;
}
// --------------------------------------------------------------------------
// Property:    Phi
// Description: The Phi property contains a D3DVALUE defining the angle, in 
//              radians, representing the outer edge of the spotlight's 
//              penumbra. 
//              
//              Points outside the penumbra are not lit by the spotlight. 
//              Points inside the penumbra and outside the umbra are 
//              illuminated with an intensity relative to their position and 
//              the Falloff value. 
//              The value can range from 0 to pi and must equal or exceed the 
//              value of the Theta property. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DLight::FGetPhi()
{
return fD3DLIGHT7.dvPhi;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLight::FSetPhi( D3DVALUE pPhi )
{
fD3DLIGHT7.dvPhi = pPhi;
}
// --------------------------------------------------------------------------
// Property:    Position
// Description: Contains a TD3DVector indicating the position of the light 
//              source in world space. 
//              This property has no meaning for a directional type light 
//              source. 
// --------------------------------------------------------------------------
D3DVECTOR __fastcall TD3DLight::FGetPosition()
{
return fD3DLIGHT7.dvPosition;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLight::FSetPosition( D3DVECTOR pPosition )
{
fD3DLIGHT7.dvPosition = pPosition;
}
// --------------------------------------------------------------------------
// Property:    Range
// Description: The Range property contains a D3DVALUE defining the maximum 
//              distance a light source may have an effect. 
//              
//              This property does not affect directional light sources. 
//              The maximum value is D3DLIGHT_RANGE_MAX, which is the square 
//              root of FLT_MAX. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DLight::FGetRange()
{
return fD3DLIGHT7.dvRange;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLight::FSetRange( D3DVALUE pRange )
{
fD3DLIGHT7.dvRange = pRange;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              D3DLIGHT7 structure. 
// --------------------------------------------------------------------------
dword __fastcall TD3DLight::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLight::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    Specular
// Description: The Specular property contains a TD3DColorValue component 
//              defining the specular color emitted by the light. 
// --------------------------------------------------------------------------
TD3DColorValue* __fastcall TD3DLight::FGetSpecular()
{
if (ComponentState.Contains(csDesigning) &&
    (fSpecular!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fSpecular)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fSpecular=NULL;
    }
return fSpecular;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLight::FSetSpecular( TD3DColorValue* pSpecular )
{
fSpecular = pSpecular;
}
// --------------------------------------------------------------------------
// Property:    Theta
// Description: The Theta property contains a D3DVALUE defining the angle, in 
//              radians, representing the outer edge of the spotlight's 
//              umbra. 
//              
//              Points inside the umbra are fully illuminated by the 
//              spotlight. 
//              Points outside the umbra and inside the penumbra are 
//              illuminated with an intensity relative to their position and 
//              the Falloff value. 
//              The value can range from 0 to the value of the Phi property. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DLight::FGetTheta()
{
return fD3DLIGHT7.dvTheta;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLight::FSetTheta( D3DVALUE pTheta )
{
fD3DLIGHT7.dvTheta = pTheta;
}
// --------------------------------------------------------------------------
// Property:    Type
// Description: The Type property defines the type of light source being 
//              described. 
//              
//              The possible values are: 
//              D3DLIGHT_POINT indicating a point source. 
//              D3DLIGHT_SPOT indicating a spotlight source. 
//              D3DLIGHT_DIRECTIONAL indicating a directional source. 
// --------------------------------------------------------------------------
D3DLIGHTTYPE __fastcall TD3DLight::FGetType()
{
return fD3DLIGHT7.dltType;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLight::FSetType( D3DLIGHTTYPE pType )
{
fD3DLIGHT7.dltType = pType;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TD3DLight's internal D3DLIGHT7 structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TD3DLight::Clear()
{
fAmbient = NULL;
fDiffuse = NULL;
fErrorValue = D3D_OK;
fSize = sizeof(D3DLIGHT7);
fSpecular = NULL;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
D3DLIGHT7* __fastcall TD3DLight::FGetInternal_D3DLIGHT7_Ptr()
{
if (fAmbient!=NULL) CopyMemory( &fD3DLIGHT7.dcvAmbient, fAmbient->Internal_D3DCOLORVALUE_Ptr, sizeof(D3DCOLORVALUE) );
if (fDiffuse!=NULL) CopyMemory( &fD3DLIGHT7.dcvDiffuse, fDiffuse->Internal_D3DCOLORVALUE_Ptr, sizeof(D3DCOLORVALUE) );
if (fSpecular!=NULL) CopyMemory( &fD3DLIGHT7.dcvSpecular, fSpecular->Internal_D3DCOLORVALUE_Ptr, sizeof(D3DCOLORVALUE) );
return &fD3DLIGHT7;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLight::FSetInternal_D3DLIGHT7( D3DLIGHT7* pD3DLIGHT7 )
{
if (pD3DLIGHT7==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DLight::FSetInternal_D3DLIGHT7()", "TDX_ERROR", "The supplied D3DLIGHT7* was NULL" );
    return;
    }

CopyMemory( &fD3DLIGHT7, pD3DLIGHT7, sizeof(D3DLIGHT7) );
Internal_D3DLIGHT7_Update();
}
// --------------------------------------------------------------------------
void __fastcall TD3DLight::Internal_D3DLIGHT7_Update()
{
if (fAmbient!=NULL) CopyMemory( fAmbient->Internal_D3DCOLORVALUE_Ptr, &fD3DLIGHT7.dcvAmbient, sizeof(D3DCOLORVALUE) );
if (fDiffuse!=NULL) CopyMemory( fDiffuse->Internal_D3DCOLORVALUE_Ptr, &fD3DLIGHT7.dcvDiffuse, sizeof(D3DCOLORVALUE) );
if (fSpecular!=NULL) CopyMemory( fSpecular->Internal_D3DCOLORVALUE_Ptr, &fD3DLIGHT7.dcvSpecular, sizeof(D3DCOLORVALUE) );
}

// --------------------------------------------------------------------------
