// --------------------------------------------------------------------------

// ==========================================================================
// File:         TD3DVertexBufferDesc.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               Brian Austin (documentation)
// Description:  This file contains the code for the TD3DVertexBufferDesc 
//               Component 
//
// "TDx_3DI_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TD3DVertexBufferDesc.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_3DI_Library_Defns"
#pragma link "TDx_3DI_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TD3DVertexBufferDesc*)
{
    new TD3DVertexBufferDesc(NULL);
}
// --------------------------------------------------------------------------
namespace Td3dvertexbufferdesc
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TD3DVertexBufferDesc)};
        RegisterComponents("TDx_3DI", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TD3DVertexBufferDesc::TD3DVertexBufferDesc()
// Description: The default constructor for the TD3DVertexBufferDesc object.
// --------------------------------------------------------------------------
__fastcall TD3DVertexBufferDesc::TD3DVertexBufferDesc(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
fCaps_Strings=NULL;
fFVF_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TD3DVertexBufferDesc::~TD3DVertexBufferDesc()
// Description: The destructor for the TD3DVertexBufferDesc object.
// --------------------------------------------------------------------------
__fastcall TD3DVertexBufferDesc::~TD3DVertexBufferDesc()
{
if (fCaps_Strings!=NULL) delete fCaps_Strings;
if (fFVF_Strings!=NULL) delete fFVF_Strings;
}
// --------------------------------------------------------------------------
// Property:    Caps
// Description: The Caps property describes the vertex buffer capabilities 
//              and settings. 
//              The described effect applies when the flag is set. 
//              
//              Setting no flags creates the vertex buffer in memory optimal 
//              for efficient read operations. 
// Flags:       D3DVBCAPS_DONOTCLIP -
//                No clipping information may be stored in the vertex buffer. 
//              D3DVBCAPS_OPTIMIZED -
//                Optimized vertex data may be stored in the vertex buffer. 
//                
//                This flag is not used when creating a new vertex buffer. 
//              D3DVBCAPS_SYSTEMMEMORY -
//                Create the vertex buffer in system memory. 
//                
//                Optimal for software rendering. 
//              D3DVBCAPS_WRITEONLY -
//                Create the vertex buffer in memory optimal for efficient 
//                write and rendering operations. 
//                
//                Read attempts on buffers created with this setting may 
//                result in degraded performance. 
// --------------------------------------------------------------------------
dword __fastcall TD3DVertexBufferDesc::FGetCaps()
{
return fD3DVERTEXBUFFERDESC.dwCaps;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertexBufferDesc::FSetCaps( dword pCaps )
{
fD3DVERTEXBUFFERDESC.dwCaps = pCaps;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TD3DVertexBufferDesc method or 
//              fget/fset. eg. D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TD3DVertexBufferDesc::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertexBufferDesc::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    FVF
// Description: The FVF property uses flexible vertex format flags to 
//              describe the verticies in this buffer. 
//              The described effect applies when the flag is set. 
// Flags:       D3DFVF_DIFFUSE -
//                Vertices have a diffuse color component. 
//              D3DFVF_NORMAL -
//                Vertices have a normal vector to define orientation. 
//                
//                Mutually exclusive with D3DFVF_XYZRHW. 
//              D3DFVF_POSITION_MASK -
//                Mask for position bits. 
//              D3DFVF_RESERVED0 -
//                Mask values for reserved bits in the flexible vertex 
//                format. 
//                Do not use. 
//              D3DFVF_RESERVED1 -
//                Emulate TD3DLVertex processing. 
//                
//                D3DFVF_XYZ, D3DFVF_DIFFUSE, D3DFVF_SPECULAR and D3DFVF_TEX1 
//                must also be set. 
//              D3DFVF_RESERVED2 -
//                Mask values for reserved bits in the flexible vertex 
//                format. 
//                Do not use. 
//              D3DFVF_SPECULAR -
//                Vertices have a specular color component. 
//              D3DFVF_TEX0 -
//                Vertices have no texture coordinate set. 
//              D3DFVF_TEX1 -
//                Vertices have a texture coordinate set. 
//              D3DFVF_TEX2 -
//                Vertices have 2 texture coordinate sets. 
//              D3DFVF_TEX3 -
//                Vertices have 3 texture coordinate sets. 
//              D3DFVF_TEX4 -
//                Vertices have 4 texture coordinate sets. 
//              D3DFVF_TEX5 -
//                Vertices have 5 texture coordinate sets. 
//              D3DFVF_TEX6 -
//                Vertices have 6 texture coordinate sets. 
//              D3DFVF_TEX7 -
//                Vertices have 7 texture coordinate sets. 
//              D3DFVF_TEX8 -
//                Vertices have 8 texture coordinate sets. 
//              D3DFVF_TEXCOUNT_MASK -
//                Mask value for texture flag bits. 
//              D3DFVF_TEXCOUNT_SHIFT -
//                The number of bits by which to shift an integer value that 
//                identifies the number of a texture coordinates for a 
//                vertex. 
//              D3DFVF_TEXTUREFORMAT1 -
//                Vertices have one dimensional texture coordinates. 
//              D3DFVF_TEXTUREFORMAT2 -
//                Vertices have two dimensional texture coordinates. 
//              D3DFVF_TEXTUREFORMAT3 -
//                Vertices have three dimensional texture coordinates. 
//              D3DFVF_TEXTUREFORMAT4 -
//                Vertices have four dimensional texture coordinates. 
//              D3DFVF_XYZ -
//                Untransformed vertices have their position defined in terms 
//                of (X,Y,Z). 
//                
//                Mutually exclusive with D3DFVF_XYZRHW. 
//                D3DFVF_NORMAL is required and either a color component 
//                (D3DFVF_DIFFUSE or D3DFVF_SPECULAR) or at least one texture 
//                coordinate (D3DFVF_TEX1 through D3DFVF_TEX8) must be 
//                specified. 
//              D3DFVF_XYZB1 -
//                Vertices contain position data along with a corresponding 
//                weighting (beta) value for multimatrix vertex blending. 
//                
//                Blending with up to 3 weighting values and 4 blending 
//                matrices is currently supported. 
//              D3DFVF_XYZB2 -
//                Vertices contain position data along with 2 corresponding 
//                weighting (beta) values for multimatrix vertex blending. 
//                
//                Blending with up to 3 weighting values and 4 blending 
//                matrices is currently supported. 
//              D3DFVF_XYZB3 -
//                Vertices contain position data along with 3 corresponding 
//                weighting (beta) values for multimatrix vertex blending. 
//                
//                Blending with up to 3 weighting values and 4 blending 
//                matrices is currently supported. 
//              D3DFVF_XYZB4 -
//                Vertices contain position data along with 4 corresponding 
//                weighting (beta) values for multimatrix vertex blending. 
//                
//                Blending with up to 3 weighting values and 4 blending 
//                matrices is currently supported. 
//              D3DFVF_XYZB5 -
//                Vertices contain position data along with 5 corresponding 
//                weighting (beta) values for multimatrix vertex blending. 
//                
//                Blending with up to 3 weighting values and 4 blending 
//                matrices is currently supported. 
//              D3DFVF_XYZRHW -
//                Transformed vertices have their position defined in terms 
//                of (X,Y,Z). 
//                
//                Mutually exclusive with D3DFVF_NORMAL and D3DFVF_XYZ. 
//                A color component (D3DFVF_DIFFUSE or D3DFVF_SPECULAR) or at 
//                least one texture coordinate (D3DFVF_TEX1 through 
//                D3DFVF_TEX8) must be specified. 
// --------------------------------------------------------------------------
dword __fastcall TD3DVertexBufferDesc::FGetFVF()
{
return fD3DVERTEXBUFFERDESC.dwFVF;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertexBufferDesc::FSetFVF( dword pFVF )
{
fD3DVERTEXBUFFERDESC.dwFVF = pFVF;
}
// --------------------------------------------------------------------------
// Property:    NumVertices
// Description: The NumVertices property defines how many verticies the 
//              buffer can hold. 
//              
//              The maximum value is defined by D3DMAXNUMVERTICES and is 
//              usually (0xFFFF). 
// --------------------------------------------------------------------------
dword __fastcall TD3DVertexBufferDesc::FGetNumVertices()
{
return fD3DVERTEXBUFFERDESC.dwNumVertices;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertexBufferDesc::FSetNumVertices( dword pNumVertices )
{
fD3DVERTEXBUFFERDESC.dwNumVertices = pNumVertices;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The size of the internal structure, initialized in the 
//              constructor. 
// --------------------------------------------------------------------------
dword __fastcall TD3DVertexBufferDesc::FGetSize()
{
return fD3DVERTEXBUFFERDESC.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertexBufferDesc::FSetSize( dword pSize )
{
fD3DVERTEXBUFFERDESC.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TD3DVertexBufferDesc's internal D3DVERTEXBUFFERDESC 
//              structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TD3DVertexBufferDesc::Clear()
{
fD3DVERTEXBUFFERDESC.dwCaps = 0;
fErrorValue = D3D_OK;
fD3DVERTEXBUFFERDESC.dwFVF = 0;
fD3DVERTEXBUFFERDESC.dwNumVertices = 0;
fD3DVERTEXBUFFERDESC.dwSize = sizeof(D3DVERTEXBUFFERDESC);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
D3DVERTEXBUFFERDESC* __fastcall TD3DVertexBufferDesc::FGetInternal_D3DVERTEXBUFFERDESC_Ptr()
{
return &fD3DVERTEXBUFFERDESC;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertexBufferDesc::FSetInternal_D3DVERTEXBUFFERDESC( D3DVERTEXBUFFERDESC* pD3DVERTEXBUFFERDESC )
{
if (pD3DVERTEXBUFFERDESC==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DVertexBufferDesc::FSetInternal_D3DVERTEXBUFFERDESC()", "TDX_ERROR", "The supplied D3DVERTEXBUFFERDESC* was NULL" );
    return;
    }

CopyMemory( &fD3DVERTEXBUFFERDESC, pD3DVERTEXBUFFERDESC, sizeof(D3DVERTEXBUFFERDESC) );
Internal_D3DVERTEXBUFFERDESC_Update();
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertexBufferDesc::Internal_D3DVERTEXBUFFERDESC_Update()
{
}

// --------------------------------------------------------------------------
// Method:      FGetCaps_
// Description: This method returns a TD3DVertexBufferDesc_Caps_Set<> of the 
//              flags in the current fD3DVERTEXBUFFERDESC.dwCaps. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TD3DVertexBufferDesc_Caps_Set __fastcall TD3DVertexBufferDesc::FGetCaps_()
{
TD3DVertexBufferDesc_Caps_Set TempCaps_;
TempCaps_.Clear();
if (fD3DVERTEXBUFFERDESC.dwCaps & D3DVBCAPS_DONOTCLIP) TempCaps_ = TempCaps_ << d3dvbcaps_donotclip;
if (fD3DVERTEXBUFFERDESC.dwCaps & D3DVBCAPS_OPTIMIZED) TempCaps_ = TempCaps_ << d3dvbcaps_optimized;
if (fD3DVERTEXBUFFERDESC.dwCaps & D3DVBCAPS_SYSTEMMEMORY) TempCaps_ = TempCaps_ << d3dvbcaps_systemmemory;
if (fD3DVERTEXBUFFERDESC.dwCaps & D3DVBCAPS_WRITEONLY) TempCaps_ = TempCaps_ << d3dvbcaps_writeonly;
return TempCaps_;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertexBufferDesc::FSetCaps_( TD3DVertexBufferDesc_Caps_Set pCaps_ )
{
fD3DVERTEXBUFFERDESC.dwCaps = 0;
if (pCaps_.Contains(d3dvbcaps_donotclip)) fD3DVERTEXBUFFERDESC.dwCaps |= D3DVBCAPS_DONOTCLIP;
if (pCaps_.Contains(d3dvbcaps_optimized)) fD3DVERTEXBUFFERDESC.dwCaps |= D3DVBCAPS_OPTIMIZED;
if (pCaps_.Contains(d3dvbcaps_systemmemory)) fD3DVERTEXBUFFERDESC.dwCaps |= D3DVBCAPS_SYSTEMMEMORY;
if (pCaps_.Contains(d3dvbcaps_writeonly)) fD3DVERTEXBUFFERDESC.dwCaps |= D3DVBCAPS_WRITEONLY;
}
// --------------------------------------------------------------------------
// Method:      FGetCaps_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Caps' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TD3DVertexBufferDesc::FGetCaps_Strings()
{
// if the strings have not been allocated
if (fCaps_Strings==NULL)
    {
    // attempt to allocate the strings
    fCaps_Strings = new TStringList();
    // if the allocation failed
    if (fCaps_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TD3DVertexBufferDesc::FGetCaps_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Caps_Strings" );
        return NULL;
        }
    }
fCaps_Strings->Clear();
if (fD3DVERTEXBUFFERDESC.dwCaps & D3DVBCAPS_DONOTCLIP) fCaps_Strings->Add("D3DVBCAPS_DONOTCLIP");
if (fD3DVERTEXBUFFERDESC.dwCaps & D3DVBCAPS_OPTIMIZED) fCaps_Strings->Add("D3DVBCAPS_OPTIMIZED");
if (fD3DVERTEXBUFFERDESC.dwCaps & D3DVBCAPS_SYSTEMMEMORY) fCaps_Strings->Add("D3DVBCAPS_SYSTEMMEMORY");
if (fD3DVERTEXBUFFERDESC.dwCaps & D3DVBCAPS_WRITEONLY) fCaps_Strings->Add("D3DVBCAPS_WRITEONLY");
return fCaps_Strings;
}
// --------------------------------------------------------------------------
// Method:      FGetFVF_
// Description: This method returns a TD3DVertexBufferDesc_FVF_Set<> of the 
//              flags in the current fD3DVERTEXBUFFERDESC.dwFVF. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TD3DVertexBufferDesc_FVF_Set __fastcall TD3DVertexBufferDesc::FGetFVF_()
{
TD3DVertexBufferDesc_FVF_Set TempFVF_;
TempFVF_.Clear();
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_DIFFUSE) TempFVF_ = TempFVF_ << d3dfvf_diffuse;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_NORMAL) TempFVF_ = TempFVF_ << d3dfvf_normal;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_POSITION_MASK) TempFVF_ = TempFVF_ << d3dfvf_position_mask;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_RESERVED0) TempFVF_ = TempFVF_ << d3dfvf_reserved0;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_RESERVED1) TempFVF_ = TempFVF_ << d3dfvf_reserved1;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_RESERVED2) TempFVF_ = TempFVF_ << d3dfvf_reserved2;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_SPECULAR) TempFVF_ = TempFVF_ << d3dfvf_specular;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEX0) TempFVF_ = TempFVF_ << d3dfvf_tex0;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEX1) TempFVF_ = TempFVF_ << d3dfvf_tex1;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEX2) TempFVF_ = TempFVF_ << d3dfvf_tex2;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEX3) TempFVF_ = TempFVF_ << d3dfvf_tex3;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEX4) TempFVF_ = TempFVF_ << d3dfvf_tex4;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEX5) TempFVF_ = TempFVF_ << d3dfvf_tex5;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEX6) TempFVF_ = TempFVF_ << d3dfvf_tex6;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEX7) TempFVF_ = TempFVF_ << d3dfvf_tex7;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEX8) TempFVF_ = TempFVF_ << d3dfvf_tex8;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEXCOUNT_MASK) TempFVF_ = TempFVF_ << d3dfvf_texcount_mask;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEXCOUNT_SHIFT) TempFVF_ = TempFVF_ << d3dfvf_texcount_shift;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEXTUREFORMAT1) TempFVF_ = TempFVF_ << d3dfvf_textureformat1;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEXTUREFORMAT2) TempFVF_ = TempFVF_ << d3dfvf_textureformat2;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEXTUREFORMAT3) TempFVF_ = TempFVF_ << d3dfvf_textureformat3;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEXTUREFORMAT4) TempFVF_ = TempFVF_ << d3dfvf_textureformat4;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_XYZ) TempFVF_ = TempFVF_ << d3dfvf_xyz;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_XYZB1) TempFVF_ = TempFVF_ << d3dfvf_xyzb1;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_XYZB2) TempFVF_ = TempFVF_ << d3dfvf_xyzb2;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_XYZB3) TempFVF_ = TempFVF_ << d3dfvf_xyzb3;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_XYZB4) TempFVF_ = TempFVF_ << d3dfvf_xyzb4;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_XYZB5) TempFVF_ = TempFVF_ << d3dfvf_xyzb5;
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_XYZRHW) TempFVF_ = TempFVF_ << d3dfvf_xyzrhw;
return TempFVF_;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertexBufferDesc::FSetFVF_( TD3DVertexBufferDesc_FVF_Set pFVF_ )
{
fD3DVERTEXBUFFERDESC.dwFVF = 0;
if (pFVF_.Contains(d3dfvf_diffuse)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_DIFFUSE;
if (pFVF_.Contains(d3dfvf_normal)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_NORMAL;
if (pFVF_.Contains(d3dfvf_position_mask)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_POSITION_MASK;
if (pFVF_.Contains(d3dfvf_reserved0)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_RESERVED0;
if (pFVF_.Contains(d3dfvf_reserved1)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_RESERVED1;
if (pFVF_.Contains(d3dfvf_reserved2)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_RESERVED2;
if (pFVF_.Contains(d3dfvf_specular)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_SPECULAR;
if (pFVF_.Contains(d3dfvf_tex0)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_TEX0;
if (pFVF_.Contains(d3dfvf_tex1)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_TEX1;
if (pFVF_.Contains(d3dfvf_tex2)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_TEX2;
if (pFVF_.Contains(d3dfvf_tex3)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_TEX3;
if (pFVF_.Contains(d3dfvf_tex4)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_TEX4;
if (pFVF_.Contains(d3dfvf_tex5)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_TEX5;
if (pFVF_.Contains(d3dfvf_tex6)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_TEX6;
if (pFVF_.Contains(d3dfvf_tex7)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_TEX7;
if (pFVF_.Contains(d3dfvf_tex8)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_TEX8;
if (pFVF_.Contains(d3dfvf_texcount_mask)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_TEXCOUNT_MASK;
if (pFVF_.Contains(d3dfvf_texcount_shift)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_TEXCOUNT_SHIFT;
if (pFVF_.Contains(d3dfvf_textureformat1)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_TEXTUREFORMAT1;
if (pFVF_.Contains(d3dfvf_textureformat2)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_TEXTUREFORMAT2;
if (pFVF_.Contains(d3dfvf_textureformat3)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_TEXTUREFORMAT3;
if (pFVF_.Contains(d3dfvf_textureformat4)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_TEXTUREFORMAT4;
if (pFVF_.Contains(d3dfvf_xyz)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_XYZ;
if (pFVF_.Contains(d3dfvf_xyzb1)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_XYZB1;
if (pFVF_.Contains(d3dfvf_xyzb2)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_XYZB2;
if (pFVF_.Contains(d3dfvf_xyzb3)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_XYZB3;
if (pFVF_.Contains(d3dfvf_xyzb4)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_XYZB4;
if (pFVF_.Contains(d3dfvf_xyzb5)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_XYZB5;
if (pFVF_.Contains(d3dfvf_xyzrhw)) fD3DVERTEXBUFFERDESC.dwFVF |= D3DFVF_XYZRHW;
}
// --------------------------------------------------------------------------
// Method:      FGetFVF_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'FVF' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TD3DVertexBufferDesc::FGetFVF_Strings()
{
// if the strings have not been allocated
if (fFVF_Strings==NULL)
    {
    // attempt to allocate the strings
    fFVF_Strings = new TStringList();
    // if the allocation failed
    if (fFVF_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TD3DVertexBufferDesc::FGetFVF_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various FVF_Strings" );
        return NULL;
        }
    }
fFVF_Strings->Clear();
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_DIFFUSE) fFVF_Strings->Add("D3DFVF_DIFFUSE");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_NORMAL) fFVF_Strings->Add("D3DFVF_NORMAL");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_POSITION_MASK) fFVF_Strings->Add("D3DFVF_POSITION_MASK");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_RESERVED0) fFVF_Strings->Add("D3DFVF_RESERVED0");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_RESERVED1) fFVF_Strings->Add("D3DFVF_RESERVED1");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_RESERVED2) fFVF_Strings->Add("D3DFVF_RESERVED2");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_SPECULAR) fFVF_Strings->Add("D3DFVF_SPECULAR");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEX0) fFVF_Strings->Add("D3DFVF_TEX0");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEX1) fFVF_Strings->Add("D3DFVF_TEX1");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEX2) fFVF_Strings->Add("D3DFVF_TEX2");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEX3) fFVF_Strings->Add("D3DFVF_TEX3");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEX4) fFVF_Strings->Add("D3DFVF_TEX4");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEX5) fFVF_Strings->Add("D3DFVF_TEX5");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEX6) fFVF_Strings->Add("D3DFVF_TEX6");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEX7) fFVF_Strings->Add("D3DFVF_TEX7");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEX8) fFVF_Strings->Add("D3DFVF_TEX8");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEXCOUNT_MASK) fFVF_Strings->Add("D3DFVF_TEXCOUNT_MASK");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEXCOUNT_SHIFT) fFVF_Strings->Add("D3DFVF_TEXCOUNT_SHIFT");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEXTUREFORMAT1) fFVF_Strings->Add("D3DFVF_TEXTUREFORMAT1");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEXTUREFORMAT2) fFVF_Strings->Add("D3DFVF_TEXTUREFORMAT2");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEXTUREFORMAT3) fFVF_Strings->Add("D3DFVF_TEXTUREFORMAT3");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_TEXTUREFORMAT4) fFVF_Strings->Add("D3DFVF_TEXTUREFORMAT4");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_XYZ) fFVF_Strings->Add("D3DFVF_XYZ");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_XYZB1) fFVF_Strings->Add("D3DFVF_XYZB1");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_XYZB2) fFVF_Strings->Add("D3DFVF_XYZB2");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_XYZB3) fFVF_Strings->Add("D3DFVF_XYZB3");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_XYZB4) fFVF_Strings->Add("D3DFVF_XYZB4");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_XYZB5) fFVF_Strings->Add("D3DFVF_XYZB5");
if (fD3DVERTEXBUFFERDESC.dwFVF & D3DFVF_XYZRHW) fFVF_Strings->Add("D3DFVF_XYZRHW");
return fFVF_Strings;
}
// --------------------------------------------------------------------------
