
// ==========================================================================
// File:        TDx_3DI_Library_Functions.CPP
// Description: This file implements standard functions used with the 
//              TDx_3DI_Library components.
//
// "TDx_3DI_Library"
// (c) 2002, BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

#include <vcl\vcl.h>
#pragma hdrstop

// --------------------------------------------------------------------------
#include "TDx_Library_Defns.H"
#include "TDx_Library_Functions.H"
// --------------------------------------------------------------------------
#include "TDx_3DI_Library_Defns.H"
#include "TDx_3DI_Library_Functions.H"

// --------------------------------------------------------------------------
// Func:            TDx_3DI_Library_ErrorString()
// Description:     Use this function to return the name of the error.
// --------------------------------------------------------------------------
AnsiString __fastcall TDx_3DI_Library_ErrorString(int Error)
{
AnsiString str = TDx_Library_ErrorString(Error);
if (str!="") return str;
switch (Error)
    {
    case -1: str = "TDX_ERROR"; break;
	case D3D_OK: str = "D3D_OK"; break;
	case D3DERR_BADMAJORVERSION: str = "D3DERR_BADMAJORVERSION"; break;
	case D3DERR_BADMINORVERSION: str = "D3DERR_BADMINORVERSION"; break;
	case D3DERR_COLORKEYATTACHED: str = "D3DERR_COLORKEYATTACHED"; break;
	case D3DERR_CONFLICTINGTEXTUREFILTER: str = "D3DERR_CONFLICTINGTEXTUREFILTER"; break;
	case D3DERR_CONFLICTINGTEXTUREPALETTE: str = "D3DERR_CONFLICTINGTEXTUREPALETTE"; break;
	case D3DERR_CONFLICTINGRENDERSTATE: str = "D3DERR_CONFLICTINGRENDERSTATE"; break;
	case D3DERR_DEVICEAGGREGATED: str = "D3DERR_DEVICEAGGREGATED"; break;
	case D3DERR_EXECUTE_CLIPPED_FAILED: str = "D3DERR_EXECUTE_CLIPPED_FAILED"; break;
	case D3DERR_EXECUTE_CREATE_FAILED: str = "D3DERR_EXECUTE_CREATE_FAILED"; break;
	case D3DERR_EXECUTE_DESTROY_FAILED: str = "D3DERR_EXECUTE_DESTROY_FAILED"; break;
	case D3DERR_EXECUTE_FAILED: str = "D3DERR_EXECUTE_FAILED"; break;
	case D3DERR_EXECUTE_LOCK_FAILED: str = "D3DERR_EXECUTE_LOCK_FAILED"; break;
	case D3DERR_EXECUTE_LOCKED: str = "D3DERR_EXECUTE_LOCKED"; break;
	case D3DERR_EXECUTE_NOT_LOCKED: str = "D3DERR_EXECUTE_NOT_LOCKED"; break;
	case D3DERR_EXECUTE_UNLOCK_FAILED: str = "D3DERR_EXECUTE_UNLOCK_FAILED"; break;
	case D3DERR_INBEGIN: str = "D3DERR_INBEGIN"; break;
	case D3DERR_INBEGINSTATEBLOCK: str = "D3DERR_INBEGINSTATEBLOCK"; break;
	case D3DERR_INITFAILED: str = "D3DERR_INITFAILED"; break;
	case D3DERR_INVALID_DEVICE: str = "D3DERR_INVALID_DEVICE"; break;
	case D3DERR_INVALIDCURRENTVIEWPORT: str = "D3DERR_INVALIDCURRENTVIEWPORT"; break;
	case D3DERR_INVALIDMATRIX: str = "D3DERR_INVALIDMATRIX"; break;
	case D3DERR_INVALIDPALETTE: str = "D3DERR_INVALIDPALETTE"; break;
	case D3DERR_INVALIDPRIMITIVETYPE: str = "D3DERR_INVALIDPRIMITIVETYPE"; break;
	case D3DERR_INVALIDRAMPTEXTURE: str = "D3DERR_INVALIDRAMPTEXTURE"; break;
	case D3DERR_INVALIDSTATEBLOCK: str = "D3DERR_INVALIDSTATEBLOCK"; break;
	case D3DERR_INVALIDVERTEXFORMAT: str = "D3DERR_INVALIDVERTEXFORMAT"; break;
	case D3DERR_INVALIDVERTEXTYPE: str = "D3DERR_INVALIDVERTEXTYPE"; break;
	case D3DERR_LIGHT_SET_FAILED: str = "D3DERR_LIGHT_SET_FAILED"; break;
	case D3DERR_LIGHTHASVIEWPORT: str = "D3DERR_LIGHTHASVIEWPORT"; break;
	case D3DERR_LIGHTNOTINTHISVIEWPORT: str = "D3DERR_LIGHTNOTINTHISVIEWPORT"; break;
	case D3DERR_MATERIAL_CREATE_FAILED: str = "D3DERR_MATERIAL_CREATE_FAILED"; break;
	case D3DERR_MATERIAL_DESTROY_FAILED: str = "D3DERR_MATERIAL_DESTROY_FAILED"; break;
	case D3DERR_MATERIAL_GETDATA_FAILED: str = "D3DERR_MATERIAL_GETDATA_FAILED"; break;
	case D3DERR_MATERIAL_SETDATA_FAILED: str = "D3DERR_MATERIAL_SETDATA_FAILED"; break;
	case D3DERR_MATRIX_CREATE_FAILED: str = "D3DERR_MATRIX_CREATE_FAILED"; break;
	case D3DERR_MATRIX_DESTROY_FAILED: str = "D3DERR_MATRIX_DESTROY_FAILED"; break;
	case D3DERR_MATRIX_GETDATA_FAILED: str = "D3DERR_MATRIX_GETDATA_FAILED"; break;
	case D3DERR_MATRIX_SETDATA_FAILED: str = "D3DERR_MATRIX_SETDATA_FAILED"; break;
	case D3DERR_NOCURRENTVIEWPORT: str = "D3DERR_NOCURRENTVIEWPORT"; break;
	case D3DERR_NOTINBEGIN: str = "D3DERR_NOTINBEGIN"; break;
	case D3DERR_NOTINBEGINSTATEBLOCK: str = "D3DERR_NOTINBEGINSTATEBLOCK"; break;
	case D3DERR_NOVIEWPORTS: str = "D3DERR_NOVIEWPORTS"; break;
	case D3DERR_SCENE_BEGIN_FAILED: str = "D3DERR_SCENE_BEGIN_FAILED"; break;
	case D3DERR_SCENE_END_FAILED: str = "D3DERR_SCENE_END_FAILED"; break;
	case D3DERR_SCENE_IN_SCENE: str = "D3DERR_SCENE_IN_SCENE"; break;
	case D3DERR_SCENE_NOT_IN_SCENE: str = "D3DERR_SCENE_NOT_IN_SCENE"; break;
	case D3DERR_SETVIEWPORTDATA_FAILED: str = "D3DERR_SETVIEWPORTDATA_FAILED"; break;
	case D3DERR_STENCILBUFFER_NOTPRESENT: str = "D3DERR_STENCILBUFFER_NOTPRESENT"; break;
	case D3DERR_SURFACENOTINVIDMEM: str = "D3DERR_SURFACENOTINVIDMEM"; break;
	case D3DERR_TEXTURE_BADSIZE: str = "D3DERR_TEXTURE_BADSIZE"; break;
	case D3DERR_TEXTURE_CREATE_FAILED: str = "D3DERR_TEXTURE_CREATE_FAILED"; break;
	case D3DERR_TEXTURE_DESTROY_FAILED: str = "D3DERR_TEXTURE_DESTROY_FAILED"; break;
	case D3DERR_TEXTURE_GETSURF_FAILED: str = "D3DERR_TEXTURE_GETSURF_FAILED"; break;
	case D3DERR_TEXTURE_LOAD_FAILED: str = "D3DERR_TEXTURE_LOAD_FAILED"; break;
	case D3DERR_TEXTURE_LOCK_FAILED: str = "D3DERR_TEXTURE_LOCK_FAILED"; break;
	case D3DERR_TEXTURE_LOCKED: str = "D3DERR_TEXTURE_LOCKED"; break;
	case D3DERR_TEXTURE_NO_SUPPORT: str = "D3DERR_TEXTURE_NO_SUPPORT"; break;
	case D3DERR_TEXTURE_NOT_LOCKED: str = "D3DERR_TEXTURE_NOT_LOCKED"; break;
	case D3DERR_TEXTURE_SWAP_FAILED: str = "D3DERR_TEXTURE_SWAP_FAILED"; break;
	case D3DERR_TEXTURE_UNLOCK_FAILED: str = "D3DERR_TEXTURE_UNLOCK_FAILED"; break;
	case D3DERR_TOOMANYOPERATIONS: str = "D3DERR_TOOMANYOPERATIONS"; break;
	case D3DERR_TOOMANYPRIMITIVES: str = "D3DERR_TOOMANYPRIMITIVES"; break;
	case D3DERR_UNSUPPORTEDALPHAARG: str = "D3DERR_UNSUPPORTEDALPHAARG"; break;
	case D3DERR_UNSUPPORTEDALPHAOPERATION: str = "D3DERR_UNSUPPORTEDALPHAOPERATION"; break;
	case D3DERR_UNSUPPORTEDCOLORARG: str = "D3DERR_UNSUPPORTEDCOLORARG"; break;
	case D3DERR_UNSUPPORTEDCOLOROPERATION: str = "D3DERR_UNSUPPORTEDCOLOROPERATION"; break;
	case D3DERR_UNSUPPORTEDFACTORVALUE: str = "D3DERR_UNSUPPORTEDFACTORVALUE"; break;
	case D3DERR_UNSUPPORTEDTEXTUREFILTER: str = "D3DERR_UNSUPPORTEDTEXTUREFILTER"; break;
	case D3DERR_VBUF_CREATE_FAILED: str = "D3DERR_VBUF_CREATE_FAILED"; break;
	case D3DERR_VERTEXBUFFERLOCKED: str = "D3DERR_VERTEXBUFFERLOCKED"; break;
	case D3DERR_VERTEXBUFFEROPTIMIZED: str = "D3DERR_VERTEXBUFFEROPTIMIZED"; break;
	case D3DERR_VERTEXBUFFERUNLOCKFAILED: str = "D3DERR_VERTEXBUFFERUNLOCKFAILED"; break;
	case D3DERR_VIEWPORTDATANOTSET: str = "D3DERR_VIEWPORTDATANOTSET"; break;
	case D3DERR_VIEWPORTHASNODEVICE: str = "D3DERR_VIEWPORTHASNODEVICE"; break;
	case D3DERR_WRONGTEXTUREFORMAT: str = "D3DERR_WRONGTEXTUREFORMAT"; break;
	case D3DERR_ZBUFF_NEEDS_SYSTEMMEMORY: str = "D3DERR_ZBUFF_NEEDS_SYSTEMMEMORY"; break;
	case D3DERR_ZBUFF_NEEDS_VIDEOMEMORY: str = "D3DERR_ZBUFF_NEEDS_VIDEOMEMORY"; break;
	case D3DERR_ZBUFFER_NOTPRESENT: str = "D3DERR_ZBUFFER_NOTPRESENT"; break;
    default: str = "UNKNOWN ERROR ["+IntToStr(Error)+"]";
    }
return str;
}
// --------------------------------------------------------------------------
// Func:            TDx_3DI_Libray_ErrorMessage()
// Description:     Use this function to return information about the error.
// --------------------------------------------------------------------------
AnsiString __fastcall TDx_3DI_Library_ErrorMessage(int Error)
{
AnsiString str = TDx_Library_ErrorMessage(Error);
if (str!="") return str;
switch (Error)
    {
    case -1: str = "You have attempted to call TDx_3DI_Library component function before the component has been created. Refer to the help on the various TDx_3DI_Library components Create() & Destroy() functions."; break;
	case D3D_OK: str = "No error occurred."; break;
	case D3DERR_BADMAJORVERSION: str = "The service that you requested is unavailable in this major version of DirectX. (A major version denotes a primary release, such as DirectX 6.0.)"; break;
	case D3DERR_BADMINORVERSION: str = "The service that you requested is available in this major version of DirectX, but not in this minor version. Get the latest version of the component run time from Microsoft. (A minor version denotes a secondary release, such as DirectX 6.1.)"; break;
	case D3DERR_COLORKEYATTACHED: str = "The application attempted to create a texture with a surface that uses a color key for transparency."; break;
	case D3DERR_CONFLICTINGTEXTUREFILTER: str = "The current texture filters cannot be used together."; break;
	case D3DERR_CONFLICTINGTEXTUREPALETTE: str = "The current textures cannot be used simultaneously. This generally occurs when a multitexture device requires that all palettized textures simultaneously enabled also share the same palette."; break;
	case D3DERR_CONFLICTINGRENDERSTATE: str = "The currently set render states cannot be used together."; break;
	case D3DERR_DEVICEAGGREGATED: str = "The IDirect3DDevice7::SetRenderTarget method was called on a device that was retrieved from the render target surface."; break;
	case D3DERR_EXECUTE_CLIPPED_FAILED: str = "The execute buffer could not be clipped during execution."; break;
	case D3DERR_EXECUTE_CREATE_FAILED: str = "The execute buffer could not be created. This typically occurs when no memory is available to allocate the execute buffer."; break;
	case D3DERR_EXECUTE_DESTROY_FAILED: str = "The memory for the execute buffer could not be deallocated."; break;
	case D3DERR_EXECUTE_FAILED: str = "The contents of the execute buffer are invalid and cannot be executed."; break;
	case D3DERR_EXECUTE_LOCK_FAILED: str = "The execute buffer could not be locked."; break;
	case D3DERR_EXECUTE_LOCKED: str = "The operation requested by the application could not be completed because the execute buffer is locked."; break;
	case D3DERR_EXECUTE_NOT_LOCKED: str = "The execute buffer could not be unlocked because it is not currently locked."; break;
	case D3DERR_EXECUTE_UNLOCK_FAILED: str = "The execute buffer could not be unlocked."; break;
	case D3DERR_INBEGIN: str = "The requested operation cannot be completed while scene rendering is taking place. Try again after the scene is completed and the IDirect3DDevice7::EndScene method is called."; break;
	case D3DERR_INBEGINSTATEBLOCK: str = "The operation cannot be completed while recording states for a state block. Complete recording by calling the IDirect3DDevice7::EndStateBlock method, and try again."; break;
	case D3DERR_INITFAILED: str = "A rendering device could not be created because the new device could not be initialized."; break;
	case D3DERR_INVALID_DEVICE: str = "The requested device type is not valid."; break;
	case D3DERR_INVALIDCURRENTVIEWPORT: str = "The currently selected viewport is not valid."; break;
	case D3DERR_INVALIDMATRIX: str = "The requested operation could not be completed because the combination of the currently set world, view, and projection matrices is invalid (the determinant of the combined matrix is 0)."; break;
	case D3DERR_INVALIDPALETTE: str = "The palette associated with a surface is invalid."; break;
	case D3DERR_INVALIDPRIMITIVETYPE: str = "The primitive type specified by the application is invalid."; break;
	case D3DERR_INVALIDRAMPTEXTURE: str = "Ramp mode is being used, and the texture handle in the current material does not match the current texture handle that is set as a render state."; break;
	case D3DERR_INVALIDSTATEBLOCK: str = "The state block handle is invalid."; break;
	case D3DERR_INVALIDVERTEXFORMAT: str = "The combination of flexible vertex format flags specified by the application is not valid."; break;
	case D3DERR_INVALIDVERTEXTYPE: str = "The vertex type specified by the application is invalid."; break;
	case D3DERR_LIGHT_SET_FAILED: str = "The attempt to set lighting parameters for a light object failed."; break;
	case D3DERR_LIGHTHASVIEWPORT: str = "The requested operation failed because the light object is associated with another viewport."; break;
	case D3DERR_LIGHTNOTINTHISVIEWPORT: str = "The requested operation failed because the light object has not been associated with this viewport."; break;
	case D3DERR_MATERIAL_CREATE_FAILED: str = "The material could not be created. This typically occurs when no memory is available to allocate for the material."; break;
	case D3DERR_MATERIAL_DESTROY_FAILED: str = "The memory for the material could not be deallocated."; break;
	case D3DERR_MATERIAL_GETDATA_FAILED: str = "The material parameters could not be retrieved."; break;
	case D3DERR_MATERIAL_SETDATA_FAILED: str = "The material parameters could not be set."; break;
	case D3DERR_MATRIX_CREATE_FAILED: str = "The matrix could not be created. This can occur when no memory is available to allocate for the matrix."; break;
	case D3DERR_MATRIX_DESTROY_FAILED: str = "The memory for the matrix could not be deallocated."; break;
	case D3DERR_MATRIX_GETDATA_FAILED: str = "The matrix data could not be retrieved. This can occur when the matrix was not created by the current device."; break;
	case D3DERR_MATRIX_SETDATA_FAILED: str = "The matrix data could not be set. This can occur when the matrix was not created by the current device."; break;
	case D3DERR_NOCURRENTVIEWPORT: str = "The viewport parameters could not be retrieved because none have been set."; break;
	case D3DERR_NOTINBEGIN: str = "The requested rendering operation could not be completed because scene rendering has not begun. Call IDirect3DDevice7::BeginScene to begin rendering, and try again."; break;
	case D3DERR_NOTINBEGINSTATEBLOCK: str = "The requested operation could not be completed because it is only valid while recording a state block. Call the IDirect3DDevice7::BeginStateBlock method, and try again."; break;
	case D3DERR_NOVIEWPORTS: str = "The requested operation failed because the device currently has no viewports associated with it."; break;
	case D3DERR_SCENE_BEGIN_FAILED: str = "Scene rendering could not begin."; break;
	case D3DERR_SCENE_END_FAILED: str = "Scene rendering could not be completed."; break;
	case D3DERR_SCENE_IN_SCENE: str = "Scene rendering could not begin because a previous scene was not completed by a call to the IDirect3DDevice7::EndScene method."; break;
	case D3DERR_SCENE_NOT_IN_SCENE: str = "Scene rendering could not be completed because a scene was not started by a previous call to the IDirect3DDevice7::BeginScene method."; break;
	case D3DERR_SETVIEWPORTDATA_FAILED: str = "The viewport parameters could not be set."; break;
	case D3DERR_STENCILBUFFER_NOTPRESENT: str = "The requested stencil buffer operation could not be completed because there is no stencil buffer attached to the render target surface."; break;
	case D3DERR_SURFACENOTINVIDMEM: str = "The device could not be created because the render target surface is not located in video memory. (Hardware-accelerated devices require video-memory render target surfaces.)"; break;
	case D3DERR_TEXTURE_BADSIZE: str = "The dimensions of a current texture are invalid. This can occur when an application attempts to use a texture that has dimensions that are not a power of 2 with a device that requires them."; break;
	case D3DERR_TEXTURE_CREATE_FAILED: str = "The texture handle for the texture could not be retrieved from the driver."; break;
	case D3DERR_TEXTURE_DESTROY_FAILED: str = "The device was unable to deallocate the texture memory."; break;
	case D3DERR_TEXTURE_GETSURF_FAILED: str = "The DirectDraw surface used to create the texture could not be retrieved."; break;
	case D3DERR_TEXTURE_LOAD_FAILED: str = "The texture could not be loaded."; break;
	case D3DERR_TEXTURE_LOCK_FAILED: str = "The texture could not be locked."; break;
	case D3DERR_TEXTURE_LOCKED: str = "The requested operation could not be completed because the texture surface is currently locked."; break;
	case D3DERR_TEXTURE_NO_SUPPORT: str = "The device does not support texture mapping."; break;
	case D3DERR_TEXTURE_NOT_LOCKED: str = "The requested operation could not be completed because the texture surface is not locked."; break;
	case D3DERR_TEXTURE_SWAP_FAILED: str = "The texture handles could not be swapped."; break;
	case D3DERR_TEXTURE_UNLOCK_FAILED: str = "The texture surface could not be unlocked."; break;
	case D3DERR_TOOMANYOPERATIONS: str = "The application is requesting more texture-filtering operations than the device supports."; break;
	case D3DERR_TOOMANYPRIMITIVES: str = "The device is unable to render the provided number of primitives in a single pass."; break;
	case D3DERR_UNSUPPORTEDALPHAARG: str = "The device does not support one of the specified texture-blending arguments for the alpha channel."; break;
	case D3DERR_UNSUPPORTEDALPHAOPERATION: str = "The device does not support one of the specified texture-blending operations for the alpha channel."; break;
	case D3DERR_UNSUPPORTEDCOLORARG: str = "The device does not support one of the specified texture-blending arguments for color values."; break;
	case D3DERR_UNSUPPORTEDCOLOROPERATION: str = "The device does not support one of the specified texture-blending operations for color values."; break;
	case D3DERR_UNSUPPORTEDFACTORVALUE: str = "The specified texture factor value is not supported by the device."; break;
	case D3DERR_UNSUPPORTEDTEXTUREFILTER: str = "The specified texture filter is not supported by the device."; break;
	case D3DERR_VBUF_CREATE_FAILED: str = "The vertex buffer could not be created. This can happen when there is insufficient memory to allocate a vertex buffer."; break;
	case D3DERR_VERTEXBUFFERLOCKED: str = "The requested operation could not be completed because the vertex buffer is locked."; break;
	case D3DERR_VERTEXBUFFEROPTIMIZED: str = "The requested operation could not be completed because the vertex buffer is optimized. (The contents of optimized vertex buffers are driver-specific and considered private.)"; break;
	case D3DERR_VERTEXBUFFERUNLOCKFAILED: str = "The vertex buffer could not be unlocked because the vertex buffer memory was overrun. Be sure that your application does not write beyond the size of the vertex buffer."; break;
	case D3DERR_VIEWPORTDATANOTSET: str = "The requested operation could not be completed because viewport parameters have not yet been set. Set the viewport parameters by calling the IDirect3DDevice7::SetViewport method, and try again."; break;
	case D3DERR_VIEWPORTHASNODEVICE: str = "This value is used only by the IDirect3DDevice3 interface and its predecessors. For the IDirect3DDevice7 interface, this error value is not used. The requested operation could not be completed because the viewport has not yet been associated with a device. Associate the viewport with a rendering device by calling the IDirect3DDevice3::AddViewport method, and try again."; break;
	case D3DERR_WRONGTEXTUREFORMAT: str = "The pixel format of the texture surface is not valid."; break;
	case D3DERR_ZBUFF_NEEDS_SYSTEMMEMORY: str = "The requested operation could not be completed because the specified device requires system-memory depth-buffer surfaces. (Software rendering devices require system-memory depth buffers.)"; break;
	case D3DERR_ZBUFF_NEEDS_VIDEOMEMORY: str = "The requested operation could not be completed because the specified device requires video-memory depth-buffer surfaces. (Hardware-accelerated devices require video-memory depth buffers.)"; break;
	case D3DERR_ZBUFFER_NOTPRESENT: str = "The requested operation could not be completed because the render target surface does not have an attached depth buffer."; break;
    default: str = "UNKNOWN ERROR ["+IntToStr(Error)+"]";
    }
return str;
}
// --------------------------------------------------------------------------
