// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDx_3DVertexBuffer.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               Brian Austin (documentation)
// Description:  This file contains the code for the TDx_3DVertexBuffer 
//               Component 
//
// "TDx_3DI_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDx_3DVertexBuffer.H"
// --------------------------------------------------------------------------
// external classes used by the TDx_3DVertexBuffer component.
#include "TDx_3D.h"
// --------------------------------------------------------------------------
// external classes used by TDx_3DVertexBuffer methods.
#include "TD3DVertexBufferDesc.H"
#include "TDx_3DDevice.H"
#include "TDx_3DVertexBuffer.H"
#include "TD3DDrawPrimitiveStridedData.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_3DI_Library_Defns"
#pragma link "TDx_3DI_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDx_3DVertexBuffer*)
{
    new TDx_3DVertexBuffer(NULL);
}
// --------------------------------------------------------------------------
namespace Tdx_3dvertexbuffer
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDx_3DVertexBuffer)};
        RegisterComponents("TDx_3DI", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDx_3DVertexBuffer::TDx_3DVertexBuffer()
// Description: The default constructor for the TDx_3DVertexBuffer object.
// --------------------------------------------------------------------------
__fastcall TDx_3DVertexBuffer::TDx_3DVertexBuffer(TComponent* Owner)
    : TComponent(Owner)
{
fCreated = false;
fErrorValue = D3D_OK;
}
// --------------------------------------------------------------------------
// Destructor:  TDx_3DVertexBuffer::~TDx_3DVertexBuffer()
// Description: The destructor for the TDx_3DVertexBuffer object.
// --------------------------------------------------------------------------
__fastcall TDx_3DVertexBuffer::~TDx_3DVertexBuffer()
{
// destroy internals
if (Created) Destroy();
}
// --------------------------------------------------------------------------
// Property:    Created
// Description: The Created property is true if the internal 
//              LPDIRECT3DVERTEXBUFFER7 used in this component has been 
//              successfully created, otherwise Created is false. 
//              
//              To create the internal LPDIRECT3DVERTEXBUFFER7, call the 
//              TDx_3DVertexBuffer::Create() method. 
// --------------------------------------------------------------------------
bool __fastcall TDx_3DVertexBuffer::FGetCreated()
{
return fCreated;
}
// --------------------------------------------------------------------------
void __fastcall TDx_3DVertexBuffer::FSetCreated( bool pCreated )
{
fCreated = (pCreated && (fLPDIRECT3DVERTEXBUFFER7==NULL));
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDx_3DVertexBuffer method or 
//              fget/fset. eg. D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDx_3DVertexBuffer::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDx_3DVertexBuffer::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Method:      Create()
// Description: The Create() method is used to automatically create the 
//              internal LPDIRECT3DVERTEXBUFFER7 interface used in the 
//              TDx_3DVertexBuffer component and must be called before any 
//              methods of the TDx_3DVertexBuffer component will function. 
// Params:      pD3D - 
//                The D3D parameter ... 
//              pVertexBufferDesc - 
//                The VertexBufferDesc parameter ... 
//              pFlags - 
//                The Flags parameter ... 
// --------------------------------------------------------------------------
bool __fastcall TDx_3DVertexBuffer::Create( TDx_3D* pD3D, TD3DVertexBufferDesc* pVertexBufferDesc, dword pFlags )
{
// if the component internals have already been created, exit
if (fCreated)
    {
    fErrorValue = TDX_ALREADYCREATED;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_ALREADYCREATED", "The "+Name+"::Create() method was called when the component has already been created." );
    return false;
    }

// check parameters
if (pD3D==NULL)
	{
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_ERROR", Name+"::Create() requires you supply a Direct3DI interface created using TpD3D::Create()" );
    return false;
    }

// check parameters
if (pVertexBufferDesc==NULL)
	{
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_ERROR", Name+"::Create() requires you supply a valid TD3DVertexBufferDesc component" );
    return false;
    }

// create the internal interface
fErrorValue = pD3D->CreateVertexBuffer( pVertexBufferDesc, this );

// check for error result
if (fErrorValue!=D3D_OK)
    {
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_ERROR", Name+"::Create() failed with Error: "+TDx_3DI_Library_ErrorString(fErrorValue)+", "+TDx_3DI_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// successfully created
fCreated = true;
if (FOnCreate) FOnCreate(this);
return true;
}

// --------------------------------------------------------------------------
// Method:      Destroy()
// Description: The Destroy() method is used to automatically destroy the 
//              internal LPDIRECT3DVERTEXBUFFER7 interface used in the 
//              TDx_3DVertexBuffer component and should be called when the 
//              internal interface is no longer required. 
//              
//              Note: This method is called by the component's destructor. 
// --------------------------------------------------------------------------
bool __fastcall TDx_3DVertexBuffer::Destroy()
{
// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_NOTCREATED", "The "+Name+"::Destroy() method was called before being created successfully." );
    return false;
    }

// code that destroys the internal interfaces
if (FOnDestroy) FOnDestroy(this);

if (fLPDIRECT3DVERTEXBUFFER7==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_ERROR", "The "+Name+" component's internal fLPDIRECT3DVERTEXBUFFER7 is NULL. Aborting the Destroy()." );
    return false;
    }

try {
    fLPDIRECT3DVERTEXBUFFER7->Release();
    }
catch (...)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_ERROR", "An exception occurred in fLPDIRECT3DVERTEXBUFFER7->Release(). Check you are destroying all components in reverse order of creation." );
    }

// successful destruction
fCreated = false;
return true;
}

// --------------------------------------------------------------------------
// Method:      GetVertexBufferDesc()
// Description: The TDx_3DVertexBuffer::GetVertexBufferDesc() method 
//              retrieves the vertex buffer's description. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with the following value: 
//              DDERR_INVALIDPARAMS 
// Params:      pVBDesc - 
//                The VBDesc parameter references the TD3DVertexBufferDesc 
//                component that will hold the vertex buffer's description if 
//                the method returns successfully. 
// --------------------------------------------------------------------------
bool __fastcall TDx_3DVertexBuffer::GetVertexBufferDesc( TD3DVertexBufferDesc* pVBDesc )
{
// Original Function Definition
// HRESULT GetVertexBufferDesc(   
//  LPD3DVERTEXBUFFERDESC lpVBDesc 
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetVertexBufferDesc()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECT3DVERTEXBUFFER7->GetVertexBufferDesc( (pVBDesc==NULL) ? NULL : pVBDesc->Internal_D3DVERTEXBUFFERDESC_Ptr );

// Translate Data returned from Function
if (pVBDesc!=NULL) pVBDesc->Internal_D3DVERTEXBUFFERDESC_Update();

// Handle any Known Results
if (fErrorValue!=D3D_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetVertexBufferDesc()", TDx_3DI_Library_ErrorString(fErrorValue), TDx_3DI_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      Lock()
// Description: The TDx_3DVertexBuffer::Lock() method retrieves a pointer to 
//              the now locked vertex buffer's memory. 
//              
//              While locked, the vertex buffer can be accessed and modified 
//              as required. 
//              Attempting to render a locked vertex buffer will merely 
//              return D3DERR_VERTEXBUFFERLOCKED errors until 
//              TDx_3DVertexBuffer::Unlock() is called. 
//              Locking often causes the system to hold Win16Mutex (also 
//              called Win16Lock), meaning GUI debuggers cannot operate 
//              during the lock period. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              D3DERR_VERTEXBUFFEROPTIMIZED 
//              DDERR_INVALIDPARAMS 
//              DDERR_OUTOFMEMORY 
//              DDERR_SURFACEBUSY 
//              DDERR_SURFACELOST 
// Params:      pFlags - 
//                The Flags parameter indicates the type of lock required. 
//                The described effect applies when the flag is set. 
//                Flags:
//                  DDLOCK_DISCARDCONTENTS -
//                    Allow Direct3D or the device driver to designate 
//                    alternative memory areas for the vertex buffer if 
//                    neccessary. 
//                    Mainly useful when clearing and rewriting the vertex 
//                    buffer. 
//                  DDLOCK_NOOVERWRITE -
//                    No vertices referred to in vertex buffer drawing calls 
//                    since the start of the last frame or last lock without 
//                    this flag will be changed during this lock. 
//                    Mainly useful when appending to the vertex buffer. 
//                  DDLOCK_NOSYSLOCK -
//                    Avoid using Win16Mutex (Win16Lock) if possible. 
//                  DDLOCK_READONLY -
//                    Vertex buffer data will only be read during this lock. 
//                  DDLOCK_SURFACEMEMORYPTR -
//                    A valid vertex buffer memory pointer is retrieved. 
//                    
//                    This is the default setting. 
//                  DDLOCK_WAIT -
//                    Retry locking until a lock is obtained or an error 
//                    other than DDERR_SURFACEBUSY occurs. 
//                  DDLOCK_WRITEONLY -
//                    Vertex buffer data will only be written during this 
//                    lock. 
//              pData - 
//                The Data parameter will reference a vertex buffer memory 
//                pointer if the method returns successfully. 
//              pSize - 
//                The Size parameter will reference the memory size of the 
//                vertex buffer if the method returns successfully. 
//                
//                Set this parameter to NULL if the buffer size is not needed. 
// --------------------------------------------------------------------------
bool __fastcall TDx_3DVertexBuffer::Lock( dword pFlags, void** pData, dword* pSize )
{
// Original Function Definition
// HRESULT Lock(  DWORD   dwFlags,    LPVOID* lplpData,   LPDWORD lpdwSize 
//  ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::Lock()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECT3DVERTEXBUFFER7->Lock( (DWORD) pFlags, (LPVOID*) pData, (LPDWORD) pSize );

// Handle any Known Results
if (fErrorValue!=D3D_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::Lock()", TDx_3DI_Library_ErrorString(fErrorValue), TDx_3DI_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      Optimize()
// Description: The TDx_3DVertexBuffer::Optimize() method modifies an 
//              unlocked vertex buffer for optimal performance according to 
//              its settings and current system environment. 
//              
//              The optimal setup for the vertex buffer is automatically 
//              adjusted as circumstances dictate. 
//              As a result, you cannot TDx_3DVertexBuffer::Lock() an 
//              optimised vertex buffer or use it as the destination buffer 
//              of the TDx_3DVertexBuffer::ProcessVertices() or 
//              TDx_3DVertexBuffer::ProcessVerticesStrided() methods. 
//              Optimised vertex buffers improve performance, but since you 
//              cannot modify them, they are best used for static vertex 
//              geometries. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              D3DERR_VERTEXBUFFEROPTIMIZED 
//              D3DERR_VERTEXBUFFERLOCKED 
//              DDERR_INVALIDPARAMS 
//              DDERR_OUTOFMEMORY 
// Params:      pD3DDevice - 
//                The D3DDevice parameter references the TDx_3DDevice for which 
//                the vertex buffer is to be optimized. 
// --------------------------------------------------------------------------
bool __fastcall TDx_3DVertexBuffer::Optimize( TDx_3DDevice* pD3DDevice )
{
// Original Function Definition
// HRESULT Optimize(   
// LPDIRECT3DDEVICE7 lpD3DDevice,   
// DWORD dwFlags 
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::Optimize()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECT3DVERTEXBUFFER7->Optimize( (pD3DDevice==NULL) ? NULL : pD3DDevice->Internal_LPDIRECT3DDEVICE7, 0 );

// Handle any Known Results
if (fErrorValue!=D3D_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::Optimize()", TDx_3DI_Library_ErrorString(fErrorValue), TDx_3DI_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      ProcessVerticies()
// Description: The TDx_3DVertexBuffer::ProcessVertices() method processes or 
//              moves vertices from one vertex buffer to another. 
//              
//              The destination buffer calls this method, effectively 
//              processing transformed vertices into itself from a source 
//              vertex buffer. 
//              Processing consists of applying the transformation matrices 
//              of the TDx_3DDevice plus optional clipping, lighting and 
//              extents processing. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              D3DERR_INVALIDVERTEXFORMAT 
//              DDERR_INVALIDOBJECT 
//              DDERR_INVALIDPARAMS 
//              DDERR_OUTOFMEMORY 
//              DDERR_SURFACEBUSY 
//              DDERR_SURFACELOST 
// Params:      pVertexOp - 
//                The VertexOp parameter indicates how to process vertices as 
//                they are transferred. 
//                The described effect applies when the flag is set. 
//                Flags:
//                  D3DVOP_CLIP -
//                    Transform and clip vertices using the viewing frustrum. 
//                    Cannot be set for vertex buffers without clipping 
//                    information. 
//                    eg: those with D3DVBCAPS_DONOTCLIP set. 
//                  D3DVOP_EXTENTS -
//                    Transform and update the screen rectangle extents when 
//                    the vertices are rendered. 
//                    
//                    May improve performance, but the 
//                    TDx_3DDevice::GetClipStatus() extents are not updated 
//                    when this technique is employed. 
//                  D3DVOP_LIGHT -
//                    Transform and light the vertices. 
//                  D3DVOP_TRANSFORM -
//                    Transform the vertices using the world, view and 
//                    projection matrices of the TDx_3DDevice. 
//                    
//                    This flag must always be set or the method will fail, 
//                    returning DDERR_INVALIDPARAMS. 
//              pDestIndex - 
//                The DestIndex parameter indicates where processed vertices 
//                are to be placed in this, the destination buffer. 
//              pCount - 
//                The Count parameter defines how many of the source buffer 
//                vertices to process. 
//              pSrcBuffer - 
//                The SrcBuffer parameter references the source 
//                TDx_3DVertexBuffer. 
//              pSrcIndex - 
//                The SrcIndex parameter indicates where in the source buffer 
//                to begin processing. 
//              pD3DDevice - 
//                The D3DDevice parameter references the TDx_3DDevice that is 
//                being used to transform the vertices. 
//              pFlags - 
//                The Flags parameter indicates whether unmodified vertices 
//                should be transferred. 
//                The described effect applies when the flag is set. 
//                
//                Set 0 for default processing, which is still copy vertices 
//                unmodified by the current vertex operation from the source to 
//                the destination buffer. 
//                Flags:
//                  D3DPV_DONOTCOPYDATA -
//                    Copy only those vertices modified in the current vertex 
//                    operation to the destination buffer. 
// --------------------------------------------------------------------------
bool __fastcall TDx_3DVertexBuffer::ProcessVerticies( dword pVertexOp, dword pDestIndex, dword pCount, TDx_3DVertexBuffer* pSrcBuffer, dword pSrcIndex, TDx_3DDevice* pD3DDevice, dword pFlags )
{
// Original Function Definition
// HRESULT ProcessVertices(   
//  DWORD dwVertexOp, 
//   DWORD dwDestIndex, 
//   DWORD dwCount, 
//   LPDIRECT3DVERTEXBUFFER7 lpSrcBuffer,   
// DWORD dwSrcIndex, 
//   LPDIRECT3DDEVICE7       lpD3DDevice,   
//  DWORD dwFlags 
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::ProcessVerticies()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECT3DVERTEXBUFFER7->ProcessVertices( (DWORD) pVertexOp, (DWORD) pDestIndex, (DWORD) pCount, (pSrcBuffer==NULL) ? NULL : pSrcBuffer->Internal_LPDIRECT3DVERTEXBUFFER7, (DWORD) pSrcIndex, (pD3DDevice==NULL) ? NULL : pD3DDevice->Internal_LPDIRECT3DDEVICE7, (DWORD) pFlags );

// Handle any Known Results
if (fErrorValue!=D3D_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::ProcessVerticies()", TDx_3DI_Library_ErrorString(fErrorValue), TDx_3DI_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      ProcessVerticiesStrided()
// Description: The TDx_3DVertexBuffer::ProcessVerticesStrided() method 
//              processes or moves strided vertices from one vertex buffer to 
//              another. 
//              
//              The destination buffer calls this method, effectively 
//              processing transformed strided vertices into itself from a 
//              source strided vertex buffer. 
//              Processing consists of applying the transformation matrices 
//              of the TDx_3DDevice plus optional clipping, lighting and 
//              extents processing. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              D3DERR_INVALIDVERTEXFORMAT 
//              DDERR_INVALIDOBJECT 
//              DDERR_INVALIDPARAMS 
//              DDERR_OUTOFMEMORY 
//              DDERR_SURFACEBUSY 
//              DDERR_SURFACELOST 
// Params:      pVertexOp - 
//                The VertexOp parameter indicates how to process vertices as 
//                they are transferred. 
//                The described effect applies when the flag is set. 
//                Flags:
//                  D3DVOP_CLIP -
//                    Transform and clip vertices using the viewing frustrum. 
//                    Cannot be set for vertex buffers without clipping 
//                    information. 
//                    eg: those with D3DVBCAPS_DONOTCLIP set. 
//                  D3DVOP_EXTENTS -
//                    Transform and update the screen rectangle extents when 
//                    the vertices are rendered. 
//                    
//                    May improve performance, but the 
//                    TDx_3DDevice::GetClipStatus() extents are not updated 
//                    when this technique is employed. 
//                  D3DVOP_LIGHT -
//                    Transform and light the vertices. 
//                  D3DVOP_TRANSFORM -
//                    Transform the vertices using the world, view and 
//                    projection matrices of the TDx_3DDevice. 
//                    
//                    This flag must always be set or the method will fail, 
//                    returning DDERR_INVALIDPARAMS. 
//              pDestIndex - 
//                The DestIndex parameter indicates where processed vertices 
//                are to be placed in this, the destination buffer. 
//              pCount - 
//                The Count parameter defines how many of the source buffer 
//                vertices to process. 
//              pVertexArray - 
//                The VertexArray parameter references a 
//                TD3DDrawPrimitiveStridedData component describing the 
//                vertices of the primitive to be processed. 
//              pSrcIndex - 
//                The SrcIndex parameter indicates where in the 
//                TD3DDrawPrimitiveStidedData component to begin processing 
//                vertices. 
//              pD3DDevice - 
//                The D3DDevice parameter references the TDx_3DDevice that is 
//                being used to transform the vertices. 
//              pFlags - 
//                The Flags parameter indicates whether unmodified vertices 
//                should be transferred. 
//                The described effect applies when the flag is set. 
//                
//                Set 0 for default processing, which is still copy vertices 
//                unmodified by the current vertex operation from the source to 
//                the destination buffer. 
//                Flags:
//                  DONOTCOPYDATA -
//                    Copy only those vertices modified in the current vertex 
//                    operation to the destination buffer. 
// --------------------------------------------------------------------------
bool __fastcall TDx_3DVertexBuffer::ProcessVerticiesStrided( dword pVertexOp, dword pDestIndex, dword pCount, TD3DDrawPrimitiveStridedData* pVertexArray, dword pSrcIndex, TDx_3DDevice* pD3DDevice, dword pFlags )
{
// Original Function Definition
// HRESULT ProcessVerticesStrided(   
//  DWORD dwVertexOp,   
// DWORD dwDestIndex, 
// DWORD dwCount,   
// LPD3DDRAWPRIMITIVESTRIDEDDATA lpVertexArray, 
// DWORD dwSrcIndex,   
// LPDIRECT3DDEVICE7 lpD3DDevice,   DWORD dwFlags 
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::ProcessVerticiesStrided()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECT3DVERTEXBUFFER7->ProcessVerticesStrided( (DWORD) pVertexOp, (DWORD) pDestIndex, (DWORD) pCount, (pVertexArray==NULL) ? NULL : pVertexArray->Internal_D3DDRAWPRIMITIVESTRIDEDDATA_Ptr, (DWORD) pSrcIndex, (pD3DDevice==NULL) ? NULL : pD3DDevice->Internal_LPDIRECT3DDEVICE7, (DWORD) pFlags );

// Translate Data returned from Function
if (pVertexArray!=NULL) pVertexArray->Internal_D3DDRAWPRIMITIVESTRIDEDDATA_Update();

// Handle any Known Results
if (fErrorValue!=D3D_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::ProcessVerticiesStrided()", TDx_3DI_Library_ErrorString(fErrorValue), TDx_3DI_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      Unlock()
// Description: The TDx_3DVertexBuffer::Unlock() method unlocks a previously 
//              locked vertex buffer. 
//              
//              Locked vertex buffers cannot be rendered until they are 
//              unlocked. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              D3DERR_VERTEXBUFFERUNLOCKFAILED   
//              DDERR_GENERIC 
//              DDERR_INVALIDOBJECT 
//              DDERR_INVALIDPARAMS 
//              DDERR_SURFACEBUSY 
//              DDERR_SURFACELOST 
// --------------------------------------------------------------------------
bool __fastcall TDx_3DVertexBuffer::Unlock()
{
// Original Function Definition
// HRESULT Unlock(); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::Unlock()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECT3DVERTEXBUFFER7->Unlock(  );

// Handle any Known Results
if (fErrorValue!=D3D_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::Unlock()", TDx_3DI_Library_ErrorString(fErrorValue), TDx_3DI_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Internal Interface Access
// --------------------------------------------------------------------------
LPDIRECT3DVERTEXBUFFER7 __fastcall TDx_3DVertexBuffer::FGetInternal_LPDIRECT3DVERTEXBUFFER7()
{
return fLPDIRECT3DVERTEXBUFFER7;
}
// --------------------------------------------------------------------------
LPDIRECT3DVERTEXBUFFER7* __fastcall TDx_3DVertexBuffer::FGetInternal_LPDIRECT3DVERTEXBUFFER7_Ptr()
{
return &fLPDIRECT3DVERTEXBUFFER7;
}
// --------------------------------------------------------------------------
void __fastcall TDx_3DVertexBuffer::FSetInternal_LPDIRECT3DVERTEXBUFFER7( LPDIRECT3DVERTEXBUFFER7 pLPDIRECT3DVERTEXBUFFER7 )
{
if (!fCreated)
    {
    fLPDIRECT3DVERTEXBUFFER7 = pLPDIRECT3DVERTEXBUFFER7;
    fCreated = (fLPDIRECT3DVERTEXBUFFER7!=NULL);
    }
}
// --------------------------------------------------------------------------
void __fastcall TDx_3DVertexBuffer::Internal_LPDIRECT3DVERTEXBUFFER7_Update()
{
fCreated = (fLPDIRECT3DVERTEXBUFFER7!=NULL);
}
// --------------------------------------------------------------------------
LPDIRECT3DVERTEXBUFFER __fastcall TDx_3DVertexBuffer::FGetInternal_LPDIRECT3DVERTEXBUFFER()
{
return fLPDIRECT3DVERTEXBUFFER;
}
// --------------------------------------------------------------------------
LPDIRECT3DVERTEXBUFFER* __fastcall TDx_3DVertexBuffer::FGetInternal_LPDIRECT3DVERTEXBUFFER_Ptr()
{
return &fLPDIRECT3DVERTEXBUFFER;
}
// --------------------------------------------------------------------------
void __fastcall TDx_3DVertexBuffer::FSetInternal_LPDIRECT3DVERTEXBUFFER( LPDIRECT3DVERTEXBUFFER pLPDIRECT3DVERTEXBUFFER )
{
if (!fCreated)
    {
    fLPDIRECT3DVERTEXBUFFER = pLPDIRECT3DVERTEXBUFFER;
    fCreated = (fLPDIRECT3DVERTEXBUFFER!=NULL);
    }
}
// --------------------------------------------------------------------------
void __fastcall TDx_3DVertexBuffer::Internal_LPDIRECT3DVERTEXBUFFER_Update()
{
fCreated = (fLPDIRECT3DVERTEXBUFFER7!=NULL);
}

// --------------------------------------------------------------------------
