// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDx_Direct3DVertexBuffer.CPP
// Author:       Darren Dwyer, BCB_Code_Generator v1.5
// Description:  This file contains the code for the TDx_Direct3DVertexBuffer 
//               Component 
//
// "TDx_3DI_Library v1.50"
// (c) 2001 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDx_Direct3DVertexBuffer.H"
// --------------------------------------------------------------------------
// external classes used by TDx_Direct3DVertexBuffer methods.
#include "TD3DVertexBufferDesc.H"
#include "TDx_3DDevice.H"
#include "TDx_Direct3DVertexBuffer.H"
#include "TD3DDrawPrimitiveStridedData.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_3DI_Library_Defns"
#pragma link "TDx_3DI_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3 or 4
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDx_Direct3DVertexBuffer*)
{
    new TDx_Direct3DVertexBuffer(NULL);
}
// --------------------------------------------------------------------------
namespace Tdx_direct3dvertexbuffer
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3 or 4
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDx_Direct3DVertexBuffer)};
        RegisterComponents("TDx_3DI", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDx_Direct3DVertexBuffer::TDx_Direct3DVertexBuffer()
// Description: The default constructor for the TDx_Direct3DVertexBuffer object.
// --------------------------------------------------------------------------
__fastcall TDx_Direct3DVertexBuffer::TDx_Direct3DVertexBuffer(TComponent* Owner)
    : TComponent(Owner)
{
fCreated = false;
fErrorValue = D3D_OK;
}
// --------------------------------------------------------------------------
// Destructor:  TDx_Direct3DVertexBuffer::~TDx_Direct3DVertexBuffer()
// Description: The destructor for the TDx_Direct3DVertexBuffer object.
// --------------------------------------------------------------------------
__fastcall TDx_Direct3DVertexBuffer::~TDx_Direct3DVertexBuffer()
{
// destroy internals
if (Created) Destroy();
}
// --------------------------------------------------------------------------
// Property:    Created
// Description: The Created property is true if the internal 
//              LPDIRECT3DVERTEXBUFFER7 used in this component has been 
//              successfully created, otherwise Created is false. 
//              
//              To create the internal LPDIRECT3DVERTEXBUFFER7, call the 
//              TDx_Direct3DVertexBuffer::Create() method. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Direct3DVertexBuffer::FGetCreated()
{
return fCreated;
}
// --------------------------------------------------------------------------
void __fastcall TDx_Direct3DVertexBuffer::FSetCreated( bool pCreated )
{
fCreated = (pCreated && (fLPDIRECT3DVERTEXBUFFER7==NULL));
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDx_Direct3DVertexBuffer method or 
//              fget/fset. eg. D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDx_Direct3DVertexBuffer::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDx_Direct3DVertexBuffer::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Method:      Create()
// Description: The Create() method is used to automatically create the 
//              internal LPDIRECT3DVERTEXBUFFER7 interface used in the 
//              TDx_Direct3DVertexBuffer component and must be called before 
//              any methods of the TDx_Direct3DVertexBuffer component will 
//              function. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Direct3DVertexBuffer::Create()
{
fCreated = true;
if (fCreated && FOnCreate) FOnCreate(this);
return fCreated;
}

// --------------------------------------------------------------------------
// Method:      Destroy()
// Description: The Destroy() method is used to automatically destroy the 
//              internal LPDIRECT3DVERTEXBUFFER7 interface used in the 
//              TDx_Direct3DVertexBuffer component and should be called when 
//              the internal interface is no longer required. 
//              
//              Note: This method is called by the component's destructor. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Direct3DVertexBuffer::Destroy()
{
fCreated = false;
if (FOnDestroy) FOnDestroy(this);
return !fCreated;
}

// --------------------------------------------------------------------------
// Method:      GetVertexBufferDesc()
// Description: The IDirect3DVertexBuffer7::GetVertexBufferDesc method 
//              retrieves a description of the vertex buffer. 
//              
//              Return Values 
//              If the method succeeds, the return value is D3D_OK. 
//              
//              If the method fails, the return value can be 
//              DDERR_INVALIDPARAMS or another error value. 
// Params:      pVBDesc - 
//                The VBDesc parameter ...Address of a D3DVERTEXBUFFERDESC 
//                structure to be filled with a description of the vertex 
//                buffer. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Direct3DVertexBuffer::GetVertexBufferDesc( TD3DVertexBufferDesc* pVBDesc )
{
// Original Function Definition
// HRESULT GetVertexBufferDesc(   
//  LPD3DVERTEXBUFFERDESC lpVBDesc 
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetVertexBufferDesc()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECT3DVERTEXBUFFER7->GetVertexBufferDesc( (pVBDesc==NULL) ? NULL : pVBDesc->Internal_D3DVERTEXBUFFERDESC_Ptr );

// Translate Data returned from Function
if (pVBDesc!=NULL) pVBDesc->Internal_D3DVERTEXBUFFERDESC_Update();

// Handle any Known Results
if (fErrorValue!=D3D_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetVertexBufferDesc()", TDx_3DI_Library_ErrorString(fErrorValue), TDx_3DI_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      Lock()
// Description: The IDirect3DVertexBuffer::Lock methods locks a vertex buffer 
//              and obtains a pointer to the vertex buffer memory. 
//              
//              Return Values 
//              If the method succeeds, the return value is D3D_OK. 
//              
//              If the method fails, the return value can be one of the 
//              following values: 
//              
//              D3DERR_VERTEXBUFFEROPTIMIZED 
//              DDERR_INVALIDPARAMS 
//              DDERR_OUTOFMEMORY 
//              DDERR_SURFACEBUSY 
//              DDERR_SURFACELOST 
//              
//              
//              Remarks 
//              After locking the vertex buffer, you can access the memory 
//              until a corresponding call to IDirect3DVertexBuffer7::Unlock. 
//              
//              You cannot render from a locked vertex buffer; calls to the 
//              IDirect3DDevice7::DrawIndexedPrimitiveVB or 
//              IDirect3DDevice7::DrawPrimitiveVB method using a locked 
//              buffer fail, returning D3DERR_VERTEXBUFFERLOCKED. 
//              
//              This method often causes the system to hold the Win16Mutex 
//              until you call the IDirect3DVertexBuffer7::Unlock method. GUI 
//              debuggers cannot operate while the Win16Mutex is held. 
//              ... 
// Params:      pFlags - 
//                The Flags parameter ...Flags indicating how the vertex buffer 
//                memory should be locked. 
//                Flags:
//                  DDLOCK_DISCARDCONTENTS -
//                    The DDLOCK_DISCARDCONTENTS Flag is used to...New for 
//                    DirectX 7.0. Used only with Direct3D vertex-buffer 
//                    locks. Indicates that no assumptions are made about the 
//                    contents of the vertex buffer during this lock. This 
//                    enables Direct3D or the driver to provide an 
//                    alternative memory area as the vertex buffer. This is 
//                    useful when you plan to clear the contents of the 
//                    vertex buffer and fill in new data. 
//                  DDLOCK_NOOVERWRITE -
//                    The DDLOCK_NOOVERWRITE Flag is used to...New for 
//                    DirectX 7.0. Used only with Direct3D vertex-buffer 
//                    locks. Indicates that no vertices that were referred to 
//                    in vertex-buffer DrawPrimitive calls since the start of 
//                    the frame (or the last lock without this flag) are 
//                    modified during the lock. This can be useful when you 
//                    want only to append data to the vertex buffer. 
//                  DDLOCK_NOSYSLOCK -
//                    The DDLOCK_NOSYSLOCK Flag is used to...If possible, do 
//                    not take the Win16Mutex (also known as Win16Lock). 
//                  DDLOCK_READONLY -
//                    The DDLOCK_READONLY Flag is used to...Indicates that 
//                    the memory being locked is only to be read from. 
//                  DDLOCK_SURFACEMEMORYPTR -
//                    The DDLOCK_SURFACEMEMORYPTR Flag is used 
//                    to...DIndicates that a valid memory pointer to the 
//                    vertex buffer is returned; this is the default. 
//                  DDLOCK_WAIT -
//                    The DDLOCK_WAIT Flag is used to...If a lock cannot be 
//                    obtained immediately, the method retries until a lock 
//                    is obtained or another error occurs. 
//                  DDLOCK_WRITEONLY -
//                    The DDLOCK_WRITEONLY Flag is used to...Indicates that 
//                    the memory being locked is only to be written to. 
//              pData - 
//                The Data parameter ...Address of a variable that receives the 
//                address of the vertex buffer memory if the call succeeds. 
//              pSize - 
//                The Size parameter ...Address of a variable that receives the 
//                size of the vertex buffer memory at lplpData. Set to NULL if 
//                the buffer size is not needed. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Direct3DVertexBuffer::Lock( dword pFlags, void** pData, dword* pSize )
{
// Original Function Definition
// HRESULT Lock(  DWORD   dwFlags,    LPVOID* lplpData,   LPDWORD lpdwSize 
//  ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::Lock()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECT3DVERTEXBUFFER7->Lock( (DWORD) pFlags, (LPVOID*) pData, (LPDWORD) pSize );

// Handle any Known Results
if (fErrorValue!=D3D_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::Lock()", TDx_3DI_Library_ErrorString(fErrorValue), TDx_3DI_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      Optimize()
// Description: The Optimize method is used to ...The 
//              IDirect3DVertexBuffer7::Optimize method converts an 
//              unoptimized vertex buffer into an optimized vertex buffer. 
//              
//              Return Values 
//              If the method succeeds, the return value is D3D_OK. 
//              
//              If the method fails, the return value can be one of the 
//              following values: 
//              
//              D3DERR_VERTEXBUFFEROPTIMIZED 
//              D3DERR_VERTEXBUFFERLOCKED 
//              DDERR_INVALIDPARAMS 
//              DDERR_OUTOFMEMORY 
//              
//              
//              Remarks 
//              In the legacy IDirect3DVertexBuffer interface, this method 
//              accepted a pointer to the IDirect3DDevice3 interface. 
// Params:      pD3DDevice - 
//                The D3DDevice parameter ...Address of the IDirect3DDevice7 
//                interface of the device for which this vertex buffer is to be 
//                optimized. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Direct3DVertexBuffer::Optimize( TDx_3DDevice* pD3DDevice )
{
// Original Function Definition
// HRESULT Optimize(   
// LPDIRECT3DDEVICE7 lpD3DDevice,   
// DWORD dwFlags 
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::Optimize()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECT3DVERTEXBUFFER7->Optimize( (pD3DDevice==NULL) ? NULL : pD3DDevice->Internal_LPDIRECT3DDEVICE7, 0 );

// Handle any Known Results
if (fErrorValue!=D3D_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::Optimize()", TDx_3DI_Library_ErrorString(fErrorValue), TDx_3DI_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      ProcessVerticies()
// Description: The IDirect3DVertexBuffer::ProcessVertices method processes 
//              untransformed vertices into a transformed or optimized vertex 
//              buffer. 
//              
//              Return Values 
//              If the method succeeds, the return value is D3D_OK. 
//              
//              If the method fails, the return value can be one of the 
//              following values: 
//              
//              D3DERR_INVALIDVERTEXFORMAT 
//              DDERR_INVALIDOBJECT 
//              DDERR_INVALIDPARAMS 
//              DDERR_OUTOFMEMORY 
//              DDERR_SURFACEBUSY 
//              DDERR_SURFACELOST 
//              
//              
//              Remarks 
//              Always include the D3DVOP_TRANSFORMED flag in the dwVertexOp 
//              parameter. If you do not, the method fails, returning 
//              DDERR_INVALIDPARAMS. 
//              
//              In the legacy IDirect3DVertexBuffer interface, this method 
//              accepted pointers to the IDirect3DDevice3 and 
//              IDirect3DVertexBuffer interfaces. 
// Params:      pVertexOp - 
//                The VertexOp parameter ...Flags defining how the method 
//                processes the vertices as they are transferred from the 
//                source buffer. You can specify any combination of the 
//                following flags: 
//                Flags:
//                  D3DVOP_CLIP -
//                    The D3DVOP_CLIP Flag is used to...Transform the 
//                    vertices, and clip any vertices that exist outside the 
//                    viewing frustum. This flag cannot be used with vertex 
//                    buffers that do not contain clipping information (for 
//                    example, those created with the D3DVBCAPS_DONOTCLIP 
//                    flag). 
//                  D3DVOP_EXTENTS -
//                    The D3DVOP_EXTENTS Flag is used to...Transform the 
//                    vertices, then update the extents of the screen 
//                    rectangle when the vertices are rendered. Using this 
//                    flag can potentially help performance, but the extents 
//                    returned by IDirect3DDevice7::GetClipStatus are not 
//                    updated to account for the vertices when they are 
//                    rendered. 
//                  D3DVOP_LIGHT -
//                    The D3DVOP_LIGHT Flag is used to...Light the vertices. 
//                  D3DVOP_TRANSFORM -
//                    The D3DVOP_TRANSFORM Flag is used to...Transform the 
//                    vertices, using the world, view, and projection 
//                    matrices. This flag must always be set. 
//              pDestIndex - 
//                The DestIndex parameter ...Index into the destination vertex 
//                buffer (this buffer) where the vertices are placed after 
//                processing. 
//              pCount - 
//                The Count parameter ...Number of vertices in the source 
//                buffer to process. 
//              pSrcBuffer - 
//                The SrcBuffer parameter ...Address of the 
//                IDirect3DVertexBuffer7 interface for the source vertex 
//                buffer. 
//              pSrcIndex - 
//                The SrcIndex parameter ...Index of the first vertex in the 
//                source buffer to be processed. 
//              pD3DDevice - 
//                The D3DDevice parameter ...Address of the IDirect3DDevice7 
//                interface for the device to be used to transform the 
//                vertices. 
//              pFlags - 
//                The Flags parameter ...Processing options. Set this parameter 
//                to 0 for default processing 
//                Flags:
//                  D3DPV_DONOTCOPYDATA -
//                    The D3DPV_DONOTCOPYDATA Flag is used to...to prevent 
//                    the system from copying vertex data not affected by the 
//                    current vertex operation into the destination buffer. 
//                    For more information, see Processing Vertices. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Direct3DVertexBuffer::ProcessVerticies( dword pVertexOp, dword pDestIndex, dword pCount, TDx_Direct3DVertexBuffer* pSrcBuffer, dword pSrcIndex, TDx_3DDevice* pD3DDevice, dword pFlags )
{
// Original Function Definition
// HRESULT ProcessVertices(   
//  DWORD dwVertexOp, 
//   DWORD dwDestIndex, 
//   DWORD dwCount, 
//   LPDIRECT3DVERTEXBUFFER7 lpSrcBuffer,   
// DWORD dwSrcIndex, 
//   LPDIRECT3DDEVICE7       lpD3DDevice,   
//  DWORD dwFlags 
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::ProcessVerticies()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECT3DVERTEXBUFFER7->ProcessVertices( (DWORD) pVertexOp, (DWORD) pDestIndex, (DWORD) pCount, (pSrcBuffer==NULL) ? NULL : pSrcBuffer->Internal_LPDIRECT3DVERTEXBUFFER7, (DWORD) pSrcIndex, (pD3DDevice==NULL) ? NULL : pD3DDevice->Internal_LPDIRECT3DDEVICE7, (DWORD) pFlags );

// Handle any Known Results
if (fErrorValue!=D3D_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::ProcessVerticies()", TDx_3DI_Library_ErrorString(fErrorValue), TDx_3DI_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      ProcessVerticiesStrided()
// Description: The IDirect3DVertexBuffer::ProcessVerticesStrided method 
//              processes untransformed strided vertices into a transformed 
//              or optimized vertex buffer. The ProcessVerticiesStrided 
//              method is used to ... 
//              
//              Return Values 
//              If the method succeeds, the return value is D3D_OK. 
//              
//              If the method fails, the return value can be one of the 
//              following values: 
//              
//              D3DERR_INVALIDVERTEXFORMAT 
//              DDERR_INVALIDOBJECT 
//              DDERR_INVALIDPARAMS 
//              DDERR_OUTOFMEMORY 
//              DDERR_SURFACEBUSY 
//              DDERR_SURFACELOST 
//              
//              
//              Remarks 
//              Always include the D3DVOP_TRANSFORMED flag in the dwVertexOp 
//              parameter. If you do not, the method fails, returning 
//              DDERR_INVALIDPARAMS. 
//              
//              This method was introduced with the IDirect3DVertexBuffer7 
//              interface. 
// Params:      pVertexOp - 
//                The VertexOp parameter ...Flags defining how the method 
//                processes the vertices as they are transferred from the 
//                source buffer. You can specify any combination of the 
//                following flags: 
//                Flags:
//                  D3DVOP_CLIP -
//                    The D3DVOP_CLIP Flag is used to...Transform the 
//                    vertices, and clip any vertices that exist outside the 
//                    viewing frustum. This flag cannot be used with vertex 
//                    buffers that do not contain clipping information (for 
//                    example, those created with the D3DVBCAPS_DONOTCLIP 
//                    flag). 
//                  D3DVOP_EXTENTS -
//                    The D3DVOP_EXTENTS Flag is used to...Transform the 
//                    vertices, then update the extents of the screen 
//                    rectangle when the vertices are rendered. Using this 
//                    flag can potentially help performance, but the extents 
//                    returned by IDirect3DDevice7::GetClipStatus are not 
//                    updated to account for the vertices when they are 
//                    rendered. 
//                  D3DVOP_LIGHT -
//                    The D3DVOP_LIGHT Flag is used to...Light the vertices. 
//                  D3DVOP_TRANSFORM -
//                    The D3DVOP_TRANSFORM Flag is used to...Transform the 
//                    vertices, using the world, view, and projection 
//                    matrices. This flag must always be set. 
//              pDestIndex - 
//                The DestIndex parameter ...Index into the destination vertex 
//                buffer (this buffer) where the vertices are placed after 
//                processing. 
//              pCount - 
//                The Count parameter ...Number of vertices in the source 
//                buffer to process. 
//              pVertexArray - 
//                The VertexArray parameter ...Array of 
//                D3DDRAWPRIMITIVESTRIDEDDATA structures that contains the 
//                vertices for this primitive. 
//              pSrcIndex - 
//                The SrcIndex parameter ..Index of the first vertex in the 
//                source buffer to be processed. . 
//              pD3DDevice - 
//                The D3DDevice parameter ...Address of the IDirect3DDevice7 
//                interface for the device to be used to transform the 
//                vertices. 
//              pFlags - 
//                The Flags parameter ...Processing options. Set this parameter 
//                to 0 for default processing. 
//                Flags:
//                  DONOTCOPYDATA -
//                    DONOTCOPYDATA ... to prevent the system from copying 
//                    vertex data not affected by the current vertex 
//                    operation into the destination buffer. For more 
//                    information, see Processing Vertices. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Direct3DVertexBuffer::ProcessVerticiesStrided( dword pVertexOp, dword pDestIndex, dword pCount, TD3DDrawPrimitiveStridedData* pVertexArray, dword pSrcIndex, TDx_3DDevice* pD3DDevice, dword pFlags )
{
// Original Function Definition
// HRESULT ProcessVerticesStrided(   
//  DWORD dwVertexOp,   
// DWORD dwDestIndex, 
// DWORD dwCount,   
// LPD3DDRAWPRIMITIVESTRIDEDDATA lpVertexArray, 
// DWORD dwSrcIndex,   
// LPDIRECT3DDEVICE7 lpD3DDevice,   DWORD dwFlags 
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::ProcessVerticiesStrided()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECT3DVERTEXBUFFER7->ProcessVerticesStrided( (DWORD) pVertexOp, (DWORD) pDestIndex, (DWORD) pCount, (pVertexArray==NULL) ? NULL : pVertexArray->Internal_D3DDRAWPRIMITIVESTRIDEDDATA_Ptr, (DWORD) pSrcIndex, (pD3DDevice==NULL) ? NULL : pD3DDevice->Internal_LPDIRECT3DDEVICE7, (DWORD) pFlags );

// Translate Data returned from Function
if (pVertexArray!=NULL) pVertexArray->Internal_D3DDRAWPRIMITIVESTRIDEDDATA_Update();

// Handle any Known Results
if (fErrorValue!=D3D_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::ProcessVerticiesStrided()", TDx_3DI_Library_ErrorString(fErrorValue), TDx_3DI_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      Unlock()
// Description: The IDirect3DVertexBuffer7::Unlock method unlocks a 
//              previously locked vertex buffer.   d is used to ... 
//              
//              Return Values 
//              If the method succeeds, the return value is D3D_OK. 
//              
//              If the method fails, the return value can be one of the 
//              following values: 
//              
//              D3DERR_VERTEXBUFFERUNLOCKFAILED   
//              DDERR_GENERIC 
//              DDERR_INVALIDOBJECT 
//              DDERR_INVALIDPARAMS 
//              DDERR_SURFACEBUSY 
//              DDERR_SURFACELOST 
// --------------------------------------------------------------------------
bool __fastcall TDx_Direct3DVertexBuffer::Unlock()
{
// Original Function Definition
// HRESULT Unlock(); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::Unlock()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECT3DVERTEXBUFFER7->Unlock(  );

// Handle any Known Results
if (fErrorValue!=D3D_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::Unlock()", TDx_3DI_Library_ErrorString(fErrorValue), TDx_3DI_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Internal Interface Access
// --------------------------------------------------------------------------
LPDIRECT3DVERTEXBUFFER7 __fastcall TDx_Direct3DVertexBuffer::FGetInternal_LPDIRECT3DVERTEXBUFFER7()
{
return fLPDIRECT3DVERTEXBUFFER7;
}
// --------------------------------------------------------------------------
LPDIRECT3DVERTEXBUFFER7* __fastcall TDx_Direct3DVertexBuffer::FGetInternal_LPDIRECT3DVERTEXBUFFER7_Ptr()
{
return &fLPDIRECT3DVERTEXBUFFER7;
}
// --------------------------------------------------------------------------
void __fastcall TDx_Direct3DVertexBuffer::FSetInternal_LPDIRECT3DVERTEXBUFFER7( LPDIRECT3DVERTEXBUFFER7 pLPDIRECT3DVERTEXBUFFER7 )
{
if (!fCreated)
    {
    fLPDIRECT3DVERTEXBUFFER7 = pLPDIRECT3DVERTEXBUFFER7;
    fCreated = (fLPDIRECT3DVERTEXBUFFER7!=NULL);
    }
}
// --------------------------------------------------------------------------
void __fastcall TDx_Direct3DVertexBuffer::Internal_LPDIRECT3DVERTEXBUFFER7_Update()
{
fCreated = (fLPDIRECT3DVERTEXBUFFER7!=NULL);
}
// --------------------------------------------------------------------------
LPDIRECT3DVERTEXBUFFER __fastcall TDx_Direct3DVertexBuffer::FGetInternal_LPDIRECT3DVERTEXBUFFER()
{
return fLPDIRECT3DVERTEXBUFFER;
}
// --------------------------------------------------------------------------
LPDIRECT3DVERTEXBUFFER* __fastcall TDx_Direct3DVertexBuffer::FGetInternal_LPDIRECT3DVERTEXBUFFER_Ptr()
{
return &fLPDIRECT3DVERTEXBUFFER;
}
// --------------------------------------------------------------------------
void __fastcall TDx_Direct3DVertexBuffer::FSetInternal_LPDIRECT3DVERTEXBUFFER( LPDIRECT3DVERTEXBUFFER pLPDIRECT3DVERTEXBUFFER )
{
if (!fCreated)
    {
    fLPDIRECT3DVERTEXBUFFER = pLPDIRECT3DVERTEXBUFFER;
    fCreated = (fLPDIRECT3DVERTEXBUFFER!=NULL);
    }
}
// --------------------------------------------------------------------------
void __fastcall TDx_Direct3DVertexBuffer::Internal_LPDIRECT3DVERTEXBUFFER_Update()
{
fCreated = (fLPDIRECT3DVERTEXBUFFER7!=NULL);
}

// --------------------------------------------------------------------------
